<?php


class DZSPortfolio {

    public $db_mainoptions = '';
    public $index = 0;
    public $thepath;
    public $base_url;
    public $base_path;
    public $shortcode = 'portfolio';
    public $pluginmode = "plugin";
    public $alwaysembed = 'off';
    public $notices = array();
    public $translateconst = 'dzsp';
    public $dbname_mainoptions = 'dzsp_options';
    public $sliders_index = 0;
    public $sliders_index_as = 0;
    public $fullscreen_cache_args = '';
    public $pb;
    public $plugin_justactivated = "off";

    private $adminpagename = 'page-dzsp';
    private $adminpagename_mainoptions = 'page-dzsp-mainoptions';
    private $adminpagename_batchupload = 'page-dzsp-batchupload';
    private $adminpagename_autoupdater = 'dzsp-autoupdater';
    private $capability_for_menu = 'manage_options';

    function __construct() {
        if ($this->pluginmode == 'theme') {
            $this->thepath = THEME_URL.'plugins/dzs-portfolio/';
        } else {
            $this->thepath = plugins_url('',__FILE__).'/';
        }

        $this->base_url = $this->thepath;
        $this->base_path = dirname(__FILE__).'/';

        $this->db_mainoptions = get_option($this->dbname_mainoptions);

        //print_r($this->db_mainoptions);
        //
        if ($this->db_mainoptions == '') {
            $this->db_mainoptions = array();
        }

        $defoptions = array(
            'enable_meta_for_pages_too' => 'off',
            'keyword_all' => __('All'),
            'keyword_portfolio_items' => __('Portfolio Items'),
            'cpt_exclude_from_search' => 'off',
            'cpt_custom_permissions' => 'off',
            'embed_always' => 'off',
            'settings_image_hide_source' => 'off',
            'thumbs_full_quality' => 'medium',
            'disable_pagebuilder' => 'off',
            'twitter_token' => '',
            'twitter_token_secret' => '',
            'dzsp_translate_project_link' => '',
            'twitter_consumer_key' => '',
            'twitter_consumer_secret' => '',
            'misc_force_featured_media_over_featured_image' => 'off',
            'zoombox_settings_disablezoom' => 'peritem',
            'zoombox_settings_zoom_donotgobeyond1x' => 'off',
            'zoombox_settings_video_autoplay' => 'off',
            'use_external_uploaddir' => 'off',
            'dzsp_purchase_code' => '',
            'dzsp_purchase_code_binded' => 'off',
        );



        $this->db_mainoptions = array_merge($defoptions,(array)$this->db_mainoptions);

        load_plugin_textdomain('dzsp',false,basename(dirname(__FILE__)).'/languages');

        $this->permalink_settings_save();
        add_theme_support('post-thumbnails');



        // --- check posts
        if(isset($_GET['dzsp_shortcode_builder']) && $_GET['dzsp_shortcode_builder']=='on'){
//            dzsprx_shortcode_builder();

            include_once(dirname(__FILE__).'/tinymce/popupiframe.php');
            define('DONOTCACHEPAGE', true);
            define('DONOTMINIFY', true);

        }

        $this->check_posts();


        //$this->pb = PageBuilder::getInstance();

        add_action('init',array($this,'handle_init'));
        //add_action('wp_print_styles', array($this, 'front_embed'));
        //add_action('admin_init', array($this, 'admin_init'));
        //add_action('admin_menu', array($this, 'admin_menu'));
        //add_action('admin_head', array($this, 'admin_menu_save'));
        //add_action('admin_head', array($this,'handle_admin_head'));
        add_shortcode($this->shortcode,array($this,'show_shortcode'));
        add_shortcode('dzs_'.$this->shortcode,array($this,'show_shortcode'));
        add_shortcode("zoomfolio",array($this,'show_shortcode'));
        //add_shortcode($this->shortcode, array($this, 'show_shortcode_alt'));
        //add_shortcode('dzs_' . $this->shortcode, array($this, 'show_shortcode_alt'));
        add_action('admin_init',array($this,'handle_admin_init'));
        add_action('add_meta_boxes',array($this,'handle_add_meta_boxes'));
        add_action('admin_head',array($this,'handle_admin_head'));
        add_action('admin_menu',array($this,'handle_admin_menu'));
        add_action('admin_notices',array($this,'handle_admin_notices'));

        add_action('save_post',array($this,'admin_meta_save'));


        add_action('wp_head',array($this,'handle_wp_head'));
        add_action('wp_footer',array($this,'handle_footer'));


        add_action('wp_ajax_dzsp_ajax_mo',array($this,'post_save_mo'));
        add_action('wp_ajax_dzsp_ajax_batchupload_saveall',array($this,'ajax_batchupload_saveall'));


        add_action('wp_ajax_dzsp_hide_notifier',array($this,'ajax_hide_notifier'));
        add_action('wp_ajax_dzsp_install_demo_data',array($this,'ajax_install_demo_data'));
        add_action('wp_ajax_dzsp_delete_demo_data',array($this,'ajax_delete_demo_data'));
        add_action('wp_ajax_dzsp_get_categories',array($this,'ajax_get_categories'));
        add_action('wp_ajax_dzsp_get_tax_types',array($this,'ajax_get_tax_types'));
        add_action('wp_ajax_dzsp_preparePreview',array($this,'ajax_preparePreview'));

        // -- setting up a thumbnail for our mp4 media
        add_filter("attachment_fields_to_edit",array($this,"filter_attachment_fields_to_edit"),null,2);
        add_filter('attachment_fields_to_save',array($this,"filter_attachment_fields_to_save"),null,2);




    }

    public  function check_posts(){

//        print_r($_POST);
        if(isset($_POST['action']) && $_POST['action']=='increment_like'){

            $the_id = $_POST['post_id'];

            if(isset($_COOKIE["like_submitted_".$the_id])){
                echo 'like submitted';
                die();
            }

            $likes = get_post_meta($the_id,'dzsp_likes',true);

            if($likes==''){
                $likes =0;
            }
            $likes++;

            update_post_meta($the_id,'dzsp_likes',$likes);

            setcookie("like_submitted_".$the_id, "yes", time()+3600);

            die();
        }
        if(isset($_POST['action']) && $_POST['action']=='increment_dislike'){

            $the_id = $_POST['post_id'];
            if(isset($_COOKIE["like_submitted_".$the_id])){
                echo 'dislike submitted';
                die();
            }

            $likes = get_post_meta($the_id,'dzsp_dislikes',true);

            if($likes==''){
                $likes =0;
            }
            $likes++;

            update_post_meta($the_id,'dzsp_dislikes',$likes);

            setcookie("like_submitted_".$the_id, $likes, time()+3600);

            die();
        }
    }

    public function handle_plugin_activate(){
        $this->plugin_justactivated = "on";
//        echo 'ceva';
        $this->register_links();
        flush_rewrite_rules();
    }
    public function handle_plugin_deactivate(){

        flush_rewrite_rules();
    }
    function ajax_preparePreview() {

//        echo $_POST['postdata'];
        echo do_shortcode(stripslashes($_POST['postdata']));
        die();
    }

    function ajax_install_demo_data() {

//        echo 'hmmdada2';

//        echo $this->base_path.'class_parts/install_sample_data.php';
        include_once($this->base_path.'class_parts/install_sample_data.php');

        die();
    }

    function ajax_hide_notifier() {

//        echo 'hmmdada2';

//        echo $this->base_path.'class_parts/install_sample_data.php';
        update_option($_POST['postdata'],'hidden');

        die();
    }

    function ajax_get_tax_types() {

        $type = $_POST['postdata'];



        $taxonomy_objects = get_object_taxonomies( $type, 'objects' );
        echo json_encode( $taxonomy_objects);

        die();


    }
    function ajax_get_categories() {

        $type = $_POST['postdata'];


        $tax = '';
        if ($type == 'post') {
            $terms = get_categories('orderby=count&hide_empty=0');
        }
        if ($type == 'default') {
            $tax = 'categoryportfolio';
        }
        if ($type == 'product') {
            $tax = 'product_cat';
        }

        if(isset($_POST['taxonomy']) && $_POST['taxonomy']){
            $tax = $_POST['taxonomy'];
        }

        $terms = array();
        if($tax){
            $terms = get_terms($tax,'orderby=count&hide_empty=0');

        }
        $i = 0;
        foreach ($terms as $cat) {
            if ($i > 0) {
                echo ',';
            }

            echo ($cat->term_id);

            ++$i;
        }


        echo ';;';

        $i = 0;
        foreach ($terms as $cat) {
            if ($i > 0) {
                echo ',';
            }

            echo ($cat->name);

            ++$i;
        }




//        echo '1,2;1,2';

        die();
    }

    function ajax_delete_demo_data() {

        $demo_data = get_option('dzsp_demo_data');

//        print_r($demo_data);


        foreach($demo_data['posts'] as $pid) {
            wp_delete_post($pid);
        };

        foreach($demo_data['cats'] as $categ_ID) {
            wp_delete_term($categ_ID,'categoryportfolio');
        };

        delete_option('dzsp_demo_data');


        die();
    }

    function filter_attachment_fields_to_edit($form_fields,$post) {


        $the_id = $post->ID;
        $post_type = get_post_mime_type($the_id);


        if (strpos($post_type,"video") === false) {
            return $form_fields;
        }


        $form_fields["attachment_video_thumb"] = array(
            "label" => __("Video Thumbnail"),
            "input" => "text",
            "value" => get_post_meta($post->ID,"_attachment_video_thumb",true)
        );

        return $form_fields;
    }

    function filter_attachment_fields_to_save($post,$attachment) {
        if (isset($attachment['attachment_video_thumb'])) {
            update_post_meta($post['ID'],'_attachment_video_thumb',$attachment['attachment_video_thumb']);
        }
        return $post;
    }


    function register_links(){

        //print_r($this->db_mainoptions);
        if ($this->db_mainoptions === false) {
            $this->db_mainoptions = array(
                'keyword_all' => 'All',
            );
            //update_option('dzsp_options', $this->db_mainoptions);
            $this->db_mainoptions = get_option('dzsp_options');
        };



        register_taxonomy(
            'categoryportfolio','dzs_portfolio',array(
                'label' => __('Portfolio Categories','dzsp'),
                'query_var' => true,
                'show_ui' => true,
                'hierarchical' => true,
            )
        );


        $labels = array(
            'name' => $this->db_mainoptions['keyword_portfolio_items'],
            'singular_name' => __('Portfolio Item'),
        );

        $permalinks = get_option('dzsp_permalinks');
        //print_r($permalinks);

        $item_slug_permalink = empty($permalinks['item_base']) ? _x('zoomfolio','slug','dzsp') : $permalinks['item_base'];

        $exclude_from_search = false;

        if($this->db_mainoptions['cpt_exclude_from_search']=='on'){
            $exclude_from_search = true;
        }


        $args = array(
            'labels' => $labels,
            'public' => true,
            'has_archive' => true,
            'hierarchical' => false,
            'supports' => array('title','editor','author','thumbnail','post-thumbnail','comments','excerpt','revisions','custom-fields'),
            'rewrite' => array('slug' => $item_slug_permalink),
            'yarpp_support' => true,
            'exclude_from_search' => $exclude_from_search,
            //'taxonomies' => array('categoryportfolio'),
        );


        if($this->db_mainoptions['cpt_custom_permissions']=='on'){
            $args['capabilities'] = array(
                'edit_post' => 'dzsp_edit_post',
                'edit_posts' => 'dzsp_edit_posts',
                'edit_others_posts' => 'dzsp_edit_others_posts',
                'publish_posts' => 'dzsp_publish_posts',
                'edit_published_posts' => 'dzsp_edit_published_posts',
                'read_post' => 'dzsp_read_post',
                'read_private_posts' => 'dzsp_read_private_posts',
                'delete_post' => 'dzsp_delete_post',
                'delete_others_posts' => 'dzsp_delete_others_posts'
            );
        }


        register_post_type('dzs_portfolio',$args);

        //print_r(get_plugins());
        //====making the plugin qtranslate ready
        if (function_exists('qtrans_modifyTermFormFor')) {
            add_action('categoryportfolio_add_form','qtrans_modifyTermFormFor');
            add_action('categoryportfolio_edit_form','qtrans_modifyTermFormFor');
        }


    }

    function handle_init() {

        $this->register_links();
//        echo $this->plugin_justactivated;
        if($this->plugin_justactivated === 'on'){
            flush_rewrite_rules();
        }



        wp_enqueue_script('jquery');
        if (is_admin()) {
            if (current_user_can('edit_posts') || current_user_can('edit_pages')) {

                wp_enqueue_script('jquery-ui-core');
                wp_enqueue_script('jquery-ui-sortable');
                wp_enqueue_script('jquery-ui-droppable');
                wp_enqueue_script('dzs.zoombox',$this->thepath.'zoombox/zoombox.js');
                wp_enqueue_style('dzs.zoombox',$this->thepath.'zoombox/zoombox.css');
                wp_enqueue_script('dzs.uploader',$this->thepath.'admin/dzsuploader/upload.js');
                wp_enqueue_style('dzs.uploader',$this->thepath.'admin/dzsuploader/upload.css');
                wp_enqueue_script('dzsp.admin',$this->thepath.'admin/admin.js');
                wp_enqueue_style('dzsp.admin',$this->thepath.'admin/admin.css');
                wp_enqueue_script('htmleditor_plugin',$this->thepath.'tinymce/plugin-htmleditor.js');
                wp_enqueue_script('dzs.farbtastic',$this->thepath."colorpicker/farbtastic.js");
                wp_enqueue_style('dzs.farbtastic',$this->thepath.'colorpicker/farbtastic.css');
                //add_filter("mce_external_plugins" , array($this, 'tinymce_plugin'));
                //add_filter("mce_buttons" , array($this, 'tinymce_register_button'));


                if (isset($_GET['page']) && $_GET['page'] == $this->adminpagename_mainoptions) {



                    if(isset($_GET['dzsp_shortcode_builder']) && $_GET['dzsp_shortcode_builder']=='on'){

                        wp_enqueue_style('dzsp_shortcode_builder_style', $this->thepath . 'tinymce/popup.css');
                        wp_enqueue_script('dzsp_shortcode_builder', $this->thepath . 'tinymce/popup.js');

                        wp_enqueue_style('fontawesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css');
                        wp_enqueue_style('dzstooltip', $this->thepath . 'assets/dzstooltip/dzstooltip.css');
                        wp_enqueue_script('dzstooltip', $this->thepath . 'assets/dzstooltip/dzstooltip.js');

                        wp_enqueue_script('dzs.portfolio',$this->thepath.'dzsportfolio/dzsportfolio.js');
                        wp_enqueue_style('dzs.portfolio',$this->thepath.'dzsportfolio/dzsportfolio.css');
                        wp_enqueue_script('dzs.toggle',$this->thepath.'dzstoggle/dzstoggle.js');
                        wp_enqueue_style('dzs.toggle',$this->thepath.'dzstoggle/dzstoggle.css');

                        wp_enqueue_script('jquery.isotope',$this->thepath.'dzsportfolio/jquery.isotope.min.js');


                        wp_enqueue_style('dzsselector', $this->thepath . 'assets/dzsselector/dzsselector.css');
                        wp_enqueue_script('dzsselector', $this->thepath . 'assets/dzsselector/dzsselector.js');

                        wp_enqueue_media();
                    }else{

                    }

                    wp_enqueue_style('iphone.checkbox',$this->thepath.'admin/checkbox/checkbox.css');
                    wp_enqueue_script('iphone.checkbox',$this->thepath."admin/checkbox/checkbox.dev.js");



                }
                if (isset($_GET['page']) && $_GET['page'] == $this->adminpagename_batchupload) {
                wp_enqueue_script('dzs.uploader',$this->thepath.'admin/dzsuploader/upload.js');
                wp_enqueue_style('dzs.uploader',$this->thepath.'admin/dzsuploader/upload.css');
                }
            }
        } else {
            if ($this->db_mainoptions['embed_always'] == 'on') {
                $this->front_scripts();
            }
        }
    }

    function handle_admin_init() {

        // Add a section to the permalinks page
        add_settings_section('dzsp-permalink',__('Portfolio Items Permalink Base','dzsp'),array($this,'permalink_settings'),'permalink');
    }



    function admin_page_autoupdater(){

        ?>
        <div class="wrap">



            <?php

            $auxarray = array();


            if(isset($_GET['dzsp_purchase_remove_binded']) && $_GET['dzsp_purchase_remove_binded']=='on'){

                $this->db_mainoptions['dzsp_purchase_code_binded']='off';

                update_option($this->dbname_mainoptions,$this->db_mainoptions);

            }

            if(isset($_POST['action']) && $_POST['action']==='dzsp_update_request'){





                if(isset($_POST['dzsp_purchase_code'])){
                    $auxarray= array('dzsp_purchase_code' => $_POST['dzsp_purchase_code']);
                    $auxarray = array_merge($this->db_mainoptions, $auxarray);

                    $this->db_mainoptions= $auxarray;


                    update_option($this->dbname_mainoptions,$auxarray);
                }



            }

            $extra_class = '';
            $extra_attr = '';
            $form_method = "POST";
            $form_action = "";
            $disable_button = '';

            $lab = 'dzsp_purchase_code';

            if($this->db_mainoptions['dzsp_purchase_code_binded']=='on'){
                $extra_attr = ' disabled';
                $disable_button = ' <input type="hidden" name="purchase_code" value="'.$this->db_mainoptions[$lab].'"/><input type="hidden" name="site_url" value="'.site_url().'"/><input type="hidden" name="redirect_url" value="'.add_query_arg('dzsp_purchase_remove_binded','on',dzs_curr_url()).'"/><button class="button-secondary" name="action" value="dzsp_purchase_code_disable">'.__("Disable Key").'</button>';
                $form_action=' action="http://zoomthe.me/updater_dzsp/servezip.php"';
            }





            echo '<form'.$form_action.' class="mainsettings" method="'.$form_method.'">';

            echo '
                <div class="setting">
                    <div class="label">'.__('Purchase Code','dzsp').'</div>
                    '.DZSHelpers::generate_input_text($lab,array('val' => '','seekval' => $this->db_mainoptions[$lab],'class' => $extra_class,'extra_attr' => $extra_attr)).$disable_button.'
                    <div class="sidenote">'.__('You can <a href="https://lh5.googleusercontent.com/-o4WL83UU4RY/Unpayq3yUvI/AAAAAAAAJ_w/HJmso_FFLNQ/w786-h1179-no/puchase.jpg" target="“_blank”">find it here</a> ','dzsp').'</div>
                </div>';


            if($this->db_mainoptions['dzsp_purchase_code_binded']=='on'){
                echo '</form><form class="mainsettings" method="post">';
            }

            echo '<p><button class="button-primary" name="action" value="dzsp_update_request">'.__("Update").'</button></p>';

            if(isset($_POST['action']) && $_POST['action']==='dzsp_update_request'){



//            echo 'ceva';


//            die();



                $aux = 'http://zoomthe.me/updater_dzsp/servezip.php?purchase_code='.$this->db_mainoptions['dzsp_purchase_code'].'&site_url='.site_url();
                $res = DZSHelpers::get_contents($aux);

//            echo 'hmm'; echo strpos($res,'<div class="error">'); echo 'dada'; echo $res;
                if($res===false){
                    echo 'server offline';
                }else{
                    if(strpos($res,'<div class="error">')===0){
                        echo $res;


                        if(strpos($res,'<div class="error">error: in progress')===0){

                            $this->db_mainoptions['dzsp_purchase_code_binded']='on';
                            update_option($this->dbname_mainoptions,$this->db_mainoptions);
                        }
                    }else{

                        file_put_contents(dirname(__FILE__).'/update.zip', $res);
                        if(class_exists('ZipArchive')){
                            $zip = new ZipArchive;
                            $res = $zip->open(dirname(__FILE__).'/update.zip');
                            //test
                            if ($res === TRUE) {
//                echo 'ok';
                                $zip->extractTo(dirname(__FILE__));
                                $zip->close();


                                $this->db_mainoptions['dzsp_purchase_code_binded']='on';
                                update_option($this->dbname_mainoptions,$this->db_mainoptions);


                            } else {
                                echo 'failed, code:' . $res;
                            }
                            echo __('Update done.');
                        }else{

                            echo __('ZipArchive class not found.');
                        }

                    }
                }
            }





            ?>
            </form>
        </div>
    <?php
    }



    function handle_add_meta_boxes() {



        add_meta_box('dzsp_meta_options',__('DZS ZoomFolio Settings'),array($this,'admin_meta_options'),'dzs_portfolio','normal','high');
        add_meta_box('dzsp_meta_options',__('DZS ZoomFolio Settings'),array($this,'admin_meta_options'),'post','normal','high');
        add_meta_box('dzsp_meta_gallery',__('Item Gallery','dzsp'),array($this,'admin_meta_gallery'),'dzs_portfolio','side');
        add_meta_box('dzsp_meta_gallery',__('Item Gallery','dzsp'),array($this,'admin_meta_gallery'),'post','side');






        //add_meta_box( 'attachment_video_thumb', __( 'Thumbnail', 'dzsp' ), array($this,'admin_meta_attachment_video_thumb'), 'attachment', 'normal' );

        if ($this->db_mainoptions['enable_meta_for_pages_too'] == 'on') {
            add_meta_box('dzsp_meta_options',__('DZS ZoomFolio Settings'),array($this,'admin_meta_options'),'page','normal','high');
            add_meta_box('dzsp_meta_gallery',__('Item Gallery','dzsp'),array($this,'admin_meta_gallery'),'page','side');
        }
    }

    function admin_meta_attachment_video_thumb() {
        global $post;
    }

    function handle_admin_menu() {

//        add_options_page(__('Portfolio Settings','dzsp'),__('DZS Portfolio Settings','dzsp'),'manage_options','dzsp-mo',array($this,'admin_page_mainoptions'));
        $dzsvg_page = add_menu_page(__('ZoomFolio','dzsvg'),__('ZoomFolio','dzsvg'),$this->capability_for_menu,$this->adminpagename_mainoptions,array($this,'admin_page_mainoptions'),'div');
        $dzsvg_subpage = add_submenu_page($this->adminpagename_mainoptions,__('ZoomFolio Settings','dzsvg'),__('Settings','dzsvg'),$this->capability_for_menu,$this->adminpagename_mainoptions,array($this,'admin_page_mainoptions'));
        $dzsvg_subpage = add_submenu_page($this->adminpagename_mainoptions,__('Upload Multiple Photos','dzsvg'),__('Upload Multiple Photos','dzsvg'),$this->capability_for_menu,$this->adminpagename_batchupload,array($this,'admin_page_batchupload'));



        $dzsp_subpage = add_submenu_page($this->adminpagename_mainoptions,__('Autoupdater','dzsp'),__('Autoupdater','dzsp'),$this->capability_for_menu,$this->adminpagename_autoupdater,array($this,'admin_page_autoupdater'));
    }

    function misc_input_checkbox($argname,$argopts) {
        $fout = '';
        $auxtype = 'checkbox';

        if (isset($argopts['type'])) {
            if ($argopts['type'] == 'radio') {
                $auxtype = 'radio';
            }
        }
        $fout.='<input type="'.$auxtype.'"';
        $fout.=' name="'.$argname.'"';
        if (isset($argopts['class'])) {
            $fout.=' class="'.$argopts['class'].'"';
        }
        $theval = 'on';
        if (isset($argopts['val'])) {
            $fout.=' value="'.$argopts['val'].'"';
            $theval = $argopts['val'];
        } else {
            $fout.=' value="on"';
        }
        //print_r($this->db_mainoptions); print_r($argopts['seekval']);
        if (isset($argopts['seekval'])) {
            $auxsw = false;
            if (is_array($argopts['seekval'])) {
                //echo 'ceva'; print_r($argopts['seekval']);
                foreach ($argopts['seekval'] as $opt) {
                    //echo 'ceva'; echo $opt; echo
                    if ($opt == $argopts['val']) {
                        $auxsw = true;
                    }
                }
            } else {
                if ($argopts['seekval'] == $theval) {
                    //echo $argval;
                    $auxsw = true;
                }
            }
            if ($auxsw == true) {
                $fout.=' checked="checked"';
            }
        }
        $fout.='/>';
        return $fout;
    }

    function admin_page_mainoptions() {
        //print_r($this->db_mainoptions);
        //echo $this->db_mainoptions['twitter_token'];


        if(isset($_GET['dzsp_shortcode_builder']) && $_GET['dzsp_shortcode_builder']=='on'){
            dzsp_shortcode_builder();
        }else {
            ?>

            <div class="wrap">
                <h2><?php echo __('ZoomFolio Main Settings', 'dzsp'); ?></h2>

                <p><button data-src="<?php echo $this->base_url ?>readme/index.html" data-type="iframe" class="zoombox button-secondary" style="" data-bigwidth="1024" data-bigheight="768" data-scaling="fill"><?php echo __("Documentation"); ?></button> <a href="<?php $aux =  add_query_arg( 'dzsp_shortcode_builder', 'on', dzs_curr_url() ); $aux =  add_query_arg( 'from_mainpage', 'on', $aux ); echo $aux;  ?>" class=" button-secondary" style="" ><?php echo __("Shortcode Generator"); ?></a></p>

                <br/>

                <form class="mainsettings">
                    <h3><?php echo __('Admin Options', 'dzsp'); ?></h3>

                    <div class="setting">
                        <h4 class="label"><?php echo __('Replace "All" with ...', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_text('keyword_all', array('val' => '', 'seekval' => $this->db_mainoptions['keyword_all'])); ?>
                        <div class="sidenote"><?php echo __('', 'dzsp'); ?></div>
                    </div>
                    <div class="dzs-setting">
                        <h4><?php echo __('Enable Meta For Pages Too ? ', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'enable_meta_for_pages_too';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>
                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('allows to display Pages too in the Portfolio .. and set option for them', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>


                    <div class="setting">
                        <h4
                            class="label"><?php echo __('Use External wp-content Upload Directory ?', 'dzsvg'); ?></h4>
                        <?php echo $this->misc_input_checkbox('use_external_uploaddir', array('val' => 'on', 'seekval' => $this->db_mainoptions['use_external_uploaddir'])); ?>
                        <div
                            class="sidenote"><?php echo __('use an outside wp-content directory for uploading files', 'dzsvg'); ?></div>
                    </div>
                    <div class="dzs-setting">
                        <h4><?php echo __('Disable Page Builder? ', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'disable_pagebuilder';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>
                        <div class="clear"></div>
                        <div class='sidenote'><?php echo __('disable the included page builder', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>
                    <div class="dzs-setting">
                        <h4><?php echo __('Always Embed Scripts ? ', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'embed_always';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>
                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('always embed zoomfolio scripts ( on ) / embed them only when needed ( off ) ', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>
                    <div class="dzs-setting">
                        <h4><?php echo __('Hide image from right click saving ? ', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'settings_image_hide_source';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>
                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('always embed zoomfolio scripts ( on ) / embed them only when needed ( off ) ', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>
                    <div class="dzs-setting">
                        <h4><?php echo __('Always Full Quality for Thumbnails ? ', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'thumbs_full_quality';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'medium',
                                'label' => __('Medium Quality', 'dzsp'),
                            ),
                            array(
                                'value' => 'full',
                                'label' => __('Full Quality', 'dzsp'),
                            ),
                            array(
                                'value' => 'default',
                                'label' => __('Default Quality', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>
                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('always embed zoomfolio scripts ( on ) / embed them only when needed ( off ) ', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>


                    <div class="setting">
                        <h4 class="label"><?php echo __('Prefer Featured Media ', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'misc_force_featured_media_over_featured_image';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>


                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('prefer Featured Media over Featured Image always ', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>

                    <div class="setting">
                        <h4 class="label"><?php echo __('Extra CSS', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_textarea('extra_css', array('val' => '', 'seekval' => $this->db_mainoptions['extra_css'])); ?>
                        <div class="sidenote"><?php echo __('', 'dzsp'); ?></div>
                    </div>
                    <h3><?php echo __('Twitter Options', 'dzsp'); ?></h3>

                    <div class="sidenote"><?php echo __('If you want Twitter items in your portfolio, you have to input here the required oAuth keys for Twitter 1.1 -
                    you can register for an api key <a href="https://dev.twitter.com/apps/new">here</a>', 'dzsp'); ?></div>
                    <div class="setting">
                        <h4 class="label"><?php echo __('Token', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_text('twitter_token', array('val' => '', 'seekval' => $this->db_mainoptions['twitter_token'])); ?>
                        <div class="sidenote"><?php echo __('', 'dzsp'); ?></div>
                    </div>
                    <div class="setting">
                        <h4 class="label"><?php echo __('Token Secret', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_text('twitter_token_secret', array('val' => '', 'seekval' => $this->db_mainoptions['twitter_token_secret'])); ?>
                        <div class="sidenote"><?php echo __('', 'dzsp'); ?></div>
                    </div>
                    <div class="setting">
                        <h4 class="label"><?php echo __('Consumer Key', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_text('twitter_consumer_key', array('val' => '', 'seekval' => $this->db_mainoptions['twitter_consumer_key'])); ?>
                    </div>
                    <div class="setting">
                        <h4 class="label"><?php echo __('Consumer Secret', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_text('twitter_consumer_secret', array('val' => '', 'seekval' => $this->db_mainoptions['twitter_consumer_secret'])); ?>
                    </div>
                    <br/>



                    <h3><?php echo __('Translation Settings', 'dzsp'); ?></h3>

                    <?php
                    $lab = 'dzsp_translate_close';
                    ?>
                    <div class="setting">
                        <h4 class="label"><?php echo __('Translate Close', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_text($lab, array('val' => '', 'seekval' => $this->db_mainoptions[$lab])); ?>
                        <div class="sidenote"><?php echo __('', 'dzsp'); ?></div>
                    </div>

                    <?php
                    $lab = 'dzsp_translate_project_link';
                    ?>
                    <div class="setting">
                        <h4 class="label"><?php echo __('Translate "Project Link"', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_text($lab, array('val' => '', 'seekval' => $this->db_mainoptions[$lab])); ?>
                        <div class="sidenote"><?php echo __('', 'dzsp'); ?></div>
                    </div>


                    <br/>
                    <h3><?php echo __("ZoomFolio Post Type"); ?></h3>



                    <div class="setting">
                        <h4 class="label"><?php echo __('Replace "Portfolio Items" with ...', 'dzsp'); ?></h4>
                        <?php echo $this->misc_input_text('keyword_portfolio_items', array('val' => '', 'seekval' => $this->db_mainoptions['keyword_portfolio_items'])); ?>
                        <div class="sidenote"><?php echo __('', 'dzsp'); ?></div>
                    </div>


                    <div class="setting">
                        <h4 class="label"><?php echo __('Exclude from Search', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'cpt_exclude_from_search';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>


                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('exclude zoomfolio portfolio items from search', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>


                    <div class="setting">
                        <h4 class="label"><?php echo __('Use Custom Permissions', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'cpt_custom_permissions';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>


                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('use custom permission settings ie <strong>dzsp_edit_post</strong> for editing the post ', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>


                    <br/>
                    <h3><?php echo __("ZoomBox Settings"); ?></h3>


                    <div class="setting">
                        <h4 class="label"><?php echo __('Disable Zoom', 'dzszb'); ?></h4>
                        <?php
                        $lab = 'zoombox_settings_disablezoom';
                        echo DZSHelpers::generate_select($lab, array('options' => array('peritem', 'off', 'on'), 'class' => 'styleme', 'seekval' => $this->db_mainoptions[$lab]));
                        ?>
                        <div class="sidenote"><?php echo __('disable the zoom', 'dzszb'); ?></div>
                    </div>

                    <div class="setting">
                        <h4 class="label"><?php echo __('Do Not Super Zoom ', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'zoombox_settings_zoom_donotgobeyond1x';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>


                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('on images opened in zoombox there is a zoom icon - you can select to not go past the 1:1 pixel ratio when zoomed ', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>

                    <div class="setting">
                        <h4 class="label"><?php echo __('Videos Autoplay ?', 'dzsp'); ?></h4>
                        <?php
                        $lab = 'zoombox_settings_video_autoplay';
                        echo $this->misc_generate_select($lab, $this->db_mainoptions[$lab], array(
                            array(
                                'value' => 'off',
                                'label' => __('off', 'dzsp'),
                            ),
                            array(
                                'value' => 'on',
                                'label' => __('on', 'dzsp'),
                            ),
                        ), array('class' => 'styleme', 'def_value' => ''));
                        ?>


                        <div class="clear"></div>
                        <div
                            class='sidenote'><?php echo __('on images opened in zoombox there is a zoom icon - you can select to not go past the 1:1 pixel ratio when zoomed ', 'dzsp'); ?></div>
                        <div class="clear"></div>
                    </div>




                    <br/>
                    <a href='#'
                       class="button-primary save-btn save-mainoptions"><?php echo __('Save Options', 'dzsp'); ?></a>
                </form>
                <div class="saveconfirmer" style=""><img alt="" style="" id="save-ajax-loading2"
                                                         src="<?php echo site_url(); ?>/wp-admin/images/wpspin_light.gif"/>
                </div>
                <script>
                    jQuery(document).ready(function ($) {
                        dzsp_mainoptions_ready();
                        $('input:checkbox').checkbox();
                    })
                </script>
            </div>
        <?php
        }
    }

    function admin_page_batchupload() {
        //print_r($this->db_mainoptions);
        //echo $this->db_mainoptions['twitter_token'];
        ?>

        <div class="wrap">

            <div class="" style="float: left; width: 600px;">
            <h2><?php echo __('Batch Upload Photos as Portfolio Items','dzsp'); ?></h2>
            <br/>

            <h2>Multi Upload</h2>
<!--multi upload demo with HTML5 - works in modern browsers, copy the markup from here-->
<div class="dzs-multi-upload">
    <h3>Choose file(s)</h3>
    <div>
        <input class="files-upload multi-uploader" name="file_field" type="file" multiple>
    </div>
    <div class="droparea">
        <div class="instructions">drag & drop files here</div>
    </div>
    <div class="upload-list-title">The Preupload List</div>
    <ul class="upload-list">
        <li class="dummy">add files here from the button or drag them above</li>
    </ul>
    <button class="primary-button upload-button">Upload All</button>
</div>
<!--multi upload demo with HTML5 - works in modern browsers, copy the markup from here END-->
<br><hr>
            </div>
            <div class="" style="overflow: hidden; max-width: 600px;">
                <img class="fullwidth" style="width: 100%" src="https://lh3.googleusercontent.com/x1r0-ZrrCsE2C-dMN3LK5UzYYgzwtosXSIx7jzrmIhw=s1060-no"/>
            </div>

            <div class='clear' style="clear: both;"></div>
            <form class="mainsettings">
                <br>
                <div class="notice-files-uploaded"><?php echo __('Currently there are '); ?><span class="notice-files-uploaded--number">0</span> files ready for process. </div>
                <br>
                <div class="setting">
                    <div class="label"><?php echo __('Upload to Category ','dzsp'); ?></div>
                    <?php
                    $arr_opts = array('lab' => 'Uncategorized' , 'val' =>'');
                    $lab = 'category';
            $terms = get_terms('categoryportfolio','orderby=count&hide_empty=0');
//            print_r($terms);
            foreach($terms as $term){
                $auxa = array('lab' => $term->name, 'val'=>$term->term_id);
                array_push($arr_opts, $auxa);
            }
                    echo DZSHelpers::generate_select($lab,array('class' => 'styleme', 'options'=>$arr_opts));
                    ?>


                    <div class="clear"></div>
                    <div class='sidenote'><?php echo __('you can upload to a specific category ','dzsp'); ?></div>
                    <div class="clear"></div>
                </div>


                <br/>
                <a href='#' class="button-primary save-btn save-batchupload"><?php echo __('Save Options','dzsp'); ?></a>
            </form>
            <div class="saveconfirmer" style=""><img alt="" style="" id="save-ajax-loading2" src="<?php echo site_url(); ?>/wp-admin/images/wpspin_light.gif"/></div>
            <script>
                jQuery(document).ready(function($) {
//                    dzsp_mainoptions_ready();
                    dzsp_adminpage_batchupload_ready();
                })
            </script>
        </div>
        <?php
    }

    function admin_meta_gallery() {
        global $post;
        ?>
        <div id="product_images_container">
            <ul class="dzsp_item_gallery_list">
                <?php
                $product_image_gallery = '';
                if (metadata_exists('post',$post->ID,'dzsp_image_gallery')) {
                    $product_image_gallery = get_post_meta($post->ID,'dzsp_image_gallery',true);
                }

                $attachments = array_filter(explode(',',$product_image_gallery));

                if ($attachments) {
                    foreach ($attachments as $attachment_id) {
                        echo '<li class="item-element" data-id="'.$attachment_id.'">
'.wp_get_attachment_image($attachment_id,'thumbnail').'
<div class="ui-delete"></div>
</li>';
                    }
                }
                ?>
            </ul>

            <input type="hidden" id="dzsp_image_gallery" name="dzsp_image_gallery" value="<?php echo esc_attr($product_image_gallery); ?>" />
            <button class="button-secondary dzsp-add-gallery-item"><?php echo __('Add Media','dzsp'); ?></button>
        </div>
        <?php
    }

    function permalink_settings() {

        echo wpautop(__('These settings control the permalinks used for products. These settings only apply when <strong>not using "default" permalinks above</strong>.','dzsp'));

        $permalinks = get_option('dzsp_permalinks');
        $dzsp_permalink = $permalinks['item_base'];
        //echo 'ceva';

        $item_base = _x('zoomfolio','default-slug','dzsp');

        $structures = array(
            0 => '',
            1 => '/'.trailingslashit($item_base)
        );
        ?>
        <table class="form-table">
            <tbody>
                <tr>
                    <th><label><input name="dzsp_permalink" type="radio" value="<?php echo $structures[0]; ?>" class="dzsptog" <?php checked($structures[0],$dzsp_permalink); ?> /> <?php _e('Default'); ?></label></th>
                    <td><code><?php echo home_url(); ?>/?zoomfolio=sample-item</code></td>
                </tr>
                <tr>
                    <th><label><input name="dzsp_permalink" type="radio" value="<?php echo $structures[1]; ?>" class="dzsptog" <?php checked($structures[1],$dzsp_permalink); ?> /> <?php _e('Nice','dzsp'); ?></label></th>
                    <td><code><?php echo home_url(); ?>/<?php echo $item_base; ?>/sample-item/</code></td>
                </tr>
                <tr>
                    <th><label><input name="dzsp_permalink" id="dzsp_custom_selection" type="radio" value="custom" class="tog" <?php checked(in_array($dzsp_permalink,$structures),false); ?> />
                            <?php _e('Custom Base','dzsp'); ?></label></th>
                    <td>
                        <input name="dzsp_permalink_structure" id="dzsp_permalink_structure" type="text" value="<?php echo esc_attr($dzsp_permalink); ?>" class="regular-text code"> <span class="description"><?php _e('Enter a custom base to use. A base <strong>must</strong> be set or WordPress will use default instead.','dzsp'); ?></span>
                    </td>
                </tr>
            </tbody>
        </table>
        <script type="text/javascript">
            jQuery(function($) {
                jQuery('input.dzsptog').change(function() {
                    jQuery('#dzsp_permalink_structure').val(jQuery(this).val());
                });

                jQuery('#dzsp_permalink_structure').focus(function() {
                    jQuery('#dzsp_custom_selection').click();
                });
            });
        </script>
        <?php
    }

    function permalink_settings_save() {
        if (!is_admin()) {
            return;
        }

        // We need to save the options ourselves; settings api does not trigger save for the permalinks page
        if (isset($_POST['dzsp_permalink_structure']) || isset($_POST['dzsp_category_base']) && isset($_POST['dzsp_product_permalink'])) {
            // Cat and tag bases
//            $product_category_slug = dzs_clean($_POST['dzsp_product_category_slug']);
//            $product_tag_slug = dzs_clean($_POST['dzsp_product_tag_slug']);
//            $product_attribute_slug = dzs_clean($_POST['dzsp_product_attribute_slug']);

            $permalinks = get_option('dzsp_permalinks');
            if (!$permalinks)
                $permalinks = array();

//            $permalinks['category_base'] = untrailingslashit($product_category_slug);
//            $permalinks['tag_base'] = untrailingslashit($product_tag_slug);
//            $permalinks['attribute_base'] = untrailingslashit($product_attribute_slug);
            // Product base
            $product_permalink = dzs_clean($_POST['dzsp_permalink']);

            if ($product_permalink == 'custom') {
                $product_permalink = dzs_clean($_POST['dzsp_permalink_structure']);
            } elseif (empty($product_permalink)) {
                $product_permalink = false;
            }

            $permalinks['item_base'] = untrailingslashit($product_permalink);

            update_option('dzsp_permalinks',$permalinks);
        }
    }

    function misc_input_textarea($argname,$otherargs = array()) {
        $fout = '';
        $fout.='<textarea';
        $fout.=' name="'.$argname.'"';

        $margs = array(
            'class' => '',
            'val' => '',// === default value
            'seekval' => '',// ===the value to be seeked
            'type' => '',
        );
        $margs = array_merge($margs,$otherargs);



        if ($margs['class'] != '') {
            $fout.=' class="'.$margs['class'].'"';
        }
        $fout.='>';
        if (isset($margs['seekval']) && $margs['seekval'] != '') {
            $fout.=''.$margs['seekval'].'';
        } else {
            $fout.=''.$margs['val'].'';
        }
        $fout.='</textarea>';

        return $fout;
    }

    function misc_input_text($argname,$otherargs = array()) {
        $fout = '';
        $fout.='<input type="text"';
        $fout.=' name="'.$argname.'"';

        $margs = array(
            'class' => '',
            'val' => '',// === default value
            'seekval' => '',// ===the value to be seeked
            'type' => '',
        );
        $margs = array_merge($margs,$otherargs);

        if ($margs['type'] == 'colorpicker') {
            $margs['class'].=' with_colorpicker';
        }



        if ($margs['class'] != '') {
            $fout.=' class="'.$margs['class'].'"';
        }
        if (isset($margs['seekval']) && $margs['seekval'] != '') {
            //echo $argval;
            $fout.=' value="'.$margs['seekval'].'"';
        } else {
            $fout.=' value="'.$margs['val'].'"';
        }
        $fout.='/>';



        //print_r($args); print_r($otherargs);
        if ($margs['type'] == 'slider') {
            $fout.='<div id="'.$argname.'_slider" style="width:200px;"></div>';
            $fout.='<script>
jQuery(document).ready(function($){
$( "#'.$argname.'_slider" ).slider({
range: "max",
min: 8,
max: 72,
value: 15,
stop: function( event, ui ) {
//console.log($( "*[name='.$argname.']" ));
$( "*[name='.$argname.']" ).val( ui.value );
$( "*[name='.$argname.']" ).trigger( "change" );
}
});
});</script>';
        }
        if ($margs['type'] == 'colorpicker') {
            $fout.='<div class="picker-con"><div class="the-icon"></div><div class="picker"></div></div>';
            $fout.='<script>
jQuery(document).ready(function($){
jQuery(".with_colorpicker").each(function(){
        var _t = jQuery(this);
        if(_t.hasClass("treated")){
            return;
        }
        if(jQuery.fn.farbtastic){
        //console.log(_t);
        _t.next().find(".picker").farbtastic(_t);
            
        }else{ if(window.console){ console.info("declare farbtastic..."); } };
        _t.addClass("treated");

        _t.bind("change", function(){
            //console.log(_t);
            jQuery("#customstyle_body").html("body{ background-color:" + $("input[name=color_bg]").val() + "} .dzsportfolio, .dzsportfolio a{ color:" + $("input[name=color_main]").val() + "} .dzsportfolio .portitem:hover .the-title, .dzsportfolio .selector-con .categories .a-category.active { color:" + $("input[name=color_high]").val() + " }");
        });
        _t.trigger("change");
        _t.bind("click", function(){
            if(_t.next().hasClass("picker-con")){
                _t.next().find(".the-icon").eq(0).trigger("click");
            }
        })
    });
});</script>';
        }

        return $fout;
    }

    function post_save_mo() {
        $auxarray = array();
        //parsing post data
        parse_str($_POST['postdata'],$auxarray);
        print_r($auxarray);



        if ($auxarray['use_external_uploaddir'] == 'on') {

            $path_uploadfile = dirname(dirname(dirname(__FILE__))).'/upload.php';
            if (file_exists($path_uploadfile) === false) {
                copy(dirname(__FILE__).'/admin/upload.php',$path_uploadfile);
            }
            $path_uploaddir = dirname(dirname(dirname(__FILE__))).'/upload';
            if (is_dir($path_uploaddir) === false) {
                mkdir($path_uploaddir,0777);
            }
        }

        $auxarray = array_merge($this->db_mainoptions, $auxarray);

        update_option($this->dbname_mainoptions,$auxarray);
        die();
    }


    function ajax_batchupload_saveall() {
        $auxarray = array();
        //parsing post data
        parse_str($_POST['postdata'],$auxarray);
        print_r($auxarray);




        foreach($auxarray['item'] as $it){
            $args = array(
  'post_title'    => $it['name'],
  'post_status'   => 'publish',
  'post_type'   => 'dzs_portfolio',
  'post_author'   => 1,
);


// Insert the post into the database
$pid = wp_insert_post( $args );


            if(intval($auxarray['category']) > 0){
                $aux = array(intval($auxarray['category']));
                wp_set_object_terms($pid,$aux,'categoryportfolio');
            }

            update_post_meta($pid, 'dzsp_featured_media', $it['url']);
            update_post_meta($pid, 'dzsp_big_image', $it['url']);
        }
//        update_option($this->dbname_mainoptions,$auxarray);
        die();
    }

    function misc_generate_select($argname,$argval,$argopts = array(),$otherargs = array()) {
        $fout = '';
        $fout.='<select';
        $fout.=' name="'.$argname.'"';

        if (isset($otherargs['class'])) {
            $fout.=' class="'.$otherargs['class'].'"';
        }
        $fout.='>';
        //print_r($argopts);
        if (isset($otherargs['generatedcontent']) && $otherargs['generatedcontent'] != '') {
            $fout.=$otherargs['generatedcontent'];
        } else {
            foreach ($argopts as $argopt) {
                $the_label = '';
                $the_val = '';
                $str_selected = '';
                if (is_array($argopt)) {
                    $the_val = $argopt['value'];
                    $the_label = $argopt['label'];
                } else {
                    $the_val = $argopt;
                    $the_label = $argopt;
                }
                if ($the_val == $argval) {
                    $str_selected = ' selected="selected"';
                }

                $fout.='<option value="'.$the_val.'"'.$str_selected.'>'.$the_label.'</option>';
            }
        }
        $fout.='</select>';
        return $fout;
    }

    function admin_meta_options() {
        global $post,$wp_version;
        $struct_uploader = '<div class="dzs-wordpress-uploader">
<a href="#" class="button-secondary">'.__('Upload','dzsp').'</a>
</div>';
        //$wp_version = '3.4.1';
        if ($wp_version < 3.5) {
            $struct_uploader = '<div class="dzs-single-upload">
<input id="files-upload" class="" name="file_field" type="file">
</div>';
        }
        ?>
        <div class="dzsp-meta-bigcon">
            <input type="hidden" name="dzs_nonce" value="<?php echo wp_create_nonce('dzs_nonce'); ?>" />


            <?php
            echo '<div class="dzs-setting">
            <h4 class="setting-label">'.__('Select Featured Media Type','dzsp').'</h4>
                <div class="main-feed-chooser select-hidden-metastyle">';


            echo $this->misc_generate_select('dzsp_item_type',get_post_meta($post->ID,'dzsp_item_type',true),array(
                array(
                    'value' => 'thumb',
                    'label' => __('image','dzsp'),
                ),
                array(
                    'value' => 'gallery',
                    'label' => __('gallery','dzsp'),
                ),
                array(
                    'value' => 'audio',
                    'label' => __('image','dzsp'),
                ),
                array(
                    'value' => 'video',
                    'label' => __('gallery','dzsp'),
                ),
                array(
                    'value' => 'youtube',
                    'label' => __('youtube','dzsp'),
                ),
                array(
                    'value' => 'vimeo',
                    'label' => __('vimeo','dzsp'),
                ),
                array(
                    'value' => 'link',
                    'label' => __('image','dzsp'),
                ),
                array(
                    'value' => 'testimonial',
                    'label' => __('testimonial','dzsp'),
                ),
                array(
                    'value' => 'twitter',
                    'label' => __('twitter','dzsp'),
                ),
                    ),array('class' => 'textinput mainsetting','def_value' => ''));


            echo '<div class="option-con clearfix">
                    <div class="an-option" title="'.__('thumb','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-image.png'.');"></div>
                    </div>
                    
                    <div class="an-option" title="'.__('gallery','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-gallery.png'.');"></div>
                    </div>
                    
                    <div class="an-option" title="'.__('audio','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-audio.png'.');"></div>
                    </div>
                    
                    <div class="an-option" title="'.__('video','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-video.png'.');"></div>
                    </div>
                    
                    <div class="an-option" title="'.__('youtube','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-video-youtube.png'.');"></div>
                    </div>
                    
                    <div class="an-option" title="'.__('vimeo','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-video-vimeo.png'.');"></div>
                    </div>
                    
                    <div class="an-option" title="'.__('link','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-link.png'.');"></div>
                    </div>
                    
                    <div class="an-option" title="'.__('testimonial','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-testimonial.png'.');"></div>
                    </div>
                    
                    <div class="an-option" title="'.__('twitter','dzsp').'">
                    <div class="fullbg" style="background-image:url('.$this->thepath.'dzsportfolio/img/hero-type-twitter.png'.');"></div>
                    </div>
                </div>
            </div>
        </div>';
            ?>
            <div class="dzs-setting">
                <h4><?php echo __('Featured Media','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_featured_media',array('class' => 'input-big-image','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_featured_media',true))); ?>
                <?php echo $struct_uploader; ?>
                <div class="dzs-img-preview-con"><div class="dzs-img-preview"></div></div>
                <div class='sidenote mode_thumb'><?php echo __('the path to the location of the image / if you have a featured image set, there is no need to input anything here','dzsp'); ?></div>
                <div class='sidenote mode_gallery'><?php echo __('use the Item Gallery form in the right to upload the gallery ( this field is not needed ) --->','dzsp'); ?></div>
                <div class='sidenote mode_audio'><?php echo __('the path to the location of the mp3 / if you have a ogg for firefox too you can place it in the backup field below','dzsp'); ?></div>
                <div class='sidenote mode_video'><?php echo __('the path to the location of the mp4 / if you have a ogg for firefox too you can place it in the backup field below','dzsp'); ?></div>
                <div class='sidenote mode_youtube mode_vimeo'><?php echo __('input here the id of the video','dzsp'); ?></div>
                <div class='sidenote mode_link'><?php echo __('the link on which the click directs too','dzsp'); ?></div>
                <div class='sidenote mode_testimonial'><?php echo __('some testimonial text','dzsp'); ?></div>
                <div class='sidenote mode_twitter'><?php echo __('the twitter id to get the last tweet from','dzsp'); ?></div>
            </div>
            <div class="dzs-setting mode_video mode_audio">
                <h4><?php echo __('Featured Media OGG backup','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_sourceogg',array('class' => 'input-big-image','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_sourceogg',true))); ?>
                <?php echo $struct_uploader; ?>
                <div class='sidenote mode_thumb'><?php echo __('a backup ogg file for html5 streaming','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Big Image','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_big_image',array('class' => 'input-big-image','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_big_image',true))); ?>
                <?php echo $struct_uploader; ?>
                <div class="dzs-img-preview-con"><div class="dzs-img-preview"></div></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Big Gallery','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_biggallery',array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_biggallery',true))); ?>
                <div class='sidenote'><?php echo __('make the big image part of a gallery. the different items on the same page with the same gallery name will have appear in the same gallery.','dzsp'); ?></div>
            </div>



            <div class="dzs-setting">
                <h4><?php echo __('Disable Title and Subtitle','dzsp'); ?></h4>
                <?php
                $lab = 'dzsp_disable_title_subtitle';
                echo DZSHelpers::generate_select($lab,array('seekval' => get_post_meta($post->ID,$lab,true),'options' => array(
                        array(
                            'val' => 'off',
                            'lab' => __('off','dzsp'),
                        ),
                        array(
                            'val' => 'on',
                            'lab' => __('on','dzsp'),
                        ),
                    ),'class' => 'styleme','def_value' => ''));
                ?>
                <div class="clear"></div>
                <div class='sidenote'><?php echo __('disable the title and subtitle','dzsp'); ?></div>
                <div class="clear"></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Disable Content','dzsp'); ?></h4>
                <?php
                echo $this->misc_generate_select('dzsp_disable_content',get_post_meta($post->ID,'dzsp_disable_content',true),array(
                    array(
                        'value' => 'off',
                        'label' => __('off','dzsp'),
                    ),
                    array(
                        'value' => 'on',
                        'label' => __('on','dzsp'),
                    ),
                        ),array('class' => 'styleme','def_value' => ''));
                ?>
                <div class="clear"></div>
                <div class='sidenote'><?php echo __('disable the content in skin-clean and skin-accordion','dzsp'); ?></div>
                <div class="clear"></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Force Item Width','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_force_width',array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_force_width',true))); ?>
                <div class='sidenote'><?php echo __('force a specific width for this item','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Force Item Height','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_force_height',array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_force_height',true))); ?>
                <div class='sidenote'><?php echo __('force a specific height for this item','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Force Thumb Width','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_force_thumb_width',array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_force_thumb_width',true))); ?>
                <div class='sidenote'><?php echo __('force a specific width for the thumb of this item','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Force Thumb Height','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_force_thumb_height',array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_force_thumb_height',true))); ?>
                <div class='sidenote'><?php echo __('force a specific height for the thumb of this item','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Highlight Color','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_highlight_color',array('class' => '','def_value' => '','type' => 'colorpicker','seekval' => get_post_meta($post->ID,'dzsp_highlight_color',true))); ?>
                <div class='sidenote'><?php echo __('represents the overlay color of the item ( if for example the selected skin is skin-blog ) / leave blank for default ','dzsp'); ?></div>
            </div>

            <div class="dzs-setting">
                <h4><?php echo __('Subtitle','dzsp'); ?></h4>
                <?php
                $lab = 'dzsp_subtitle';
                echo $this->misc_input_text($lab,array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,$lab,true)));
                ?>
                <div class='sidenote'><?php echo __('set a subtitle for aplicable skins ( like skin-default or skin-corporate )','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Meta Order','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_meta_order',array('class' => '','def_value' => '500','seekval' => get_post_meta($post->ID,'dzsp_meta_order',true))); ?>
                <div class='sidenote'><?php echo __('used only if orderby is set to <strong>meta order</strong> in the shortcode parameters. it will display the portfolio items based on the 
        values of each portfolio item defined here','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Excerpt Length','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_excerpt_len',array('class' => '','def_value' => '500','seekval' => get_post_meta($post->ID,'dzsp_excerpt_len',true))); ?>
                <div class='sidenote'><?php echo __('Only if you are using a skin that shows the content of the portfolio item / like skin-corporate - limit number of characters to show. If you have anything entered in the Excerpt field it will pull content from there.','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Gallery Slideshow Time','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_slideshowtime',array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_slideshowtime',true))); ?>
                <div class='sidenote'><?php echo __('only for the gallery type / the time between image changes','dzsp'); ?></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Extra Classes','dzsp'); ?></h4>
                <?php echo $this->misc_input_text('dzsp_extra_classes',array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_extra_classes',true))); ?>
                <div class='sidenote'><?php echo __('[advanced] some extra classes that you want added to the portfolio item','dzsp'); ?></div>
            </div>
            <h4 class="bigger-heading"><?php echo __('Linking Settings','dzsp'); ?></h4>
            <p><img class="border-image" src="https://lh6.googleusercontent.com/-LWAgfGsX1IM/Ub5OHWlAx-I/AAAAAAAADpE/1mj0Eb6JrJc/w537-h268-no/help_structure.jpg"/></p>

            <div class="dzs-setting">
                <h4><?php echo __('Featured Area Links To....','dzsp'); ?></h4>
                <?php
                $lab = 'dzsp_link_featurearea';
                echo $this->misc_generate_select($lab,get_post_meta($post->ID,$lab,true),array(
                    array(
                        'value' => 'bigimage',
                        'label' => __('Big Image','dzsp'),
                    ),
                    array(
                        'value' => 'item',
                        'label' => __('Item URL','dzsp'),
                    ),
                    array(
                        'value' => 'customlink',
                        'label' => __('Custom Link','dzsp'),
                    ),
                    array(
                        'value' => 'content_opener',
                        'label' => __('Excerpt Open','dzsp'),
                    ),
                    array(
                        'value' => 'none',
                        'label' => __('Nowhere','dzsp'),
                    ),
                        ),array('class' => 'styleme','def_value' => ''));
                ?>
                <div class="clear"></div>
                <div class='sidenote'><?php echo __('Choose where clicking the featured area should go.','dzsp'); ?></div>
                <div class="clear"></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Open Big Image In Lightbox','dzsp'); ?></h4>
                <?php
                echo $this->misc_generate_select('dzsp_open_big_image_in_lightbox',get_post_meta($post->ID,'dzsp_open_big_image_in_lightbox',true),array(
                    array(
                        'value' => 'on',
                        'label' => __('on','dzsp'),
                    ),
                    array(
                        'value' => 'off',
                        'label' => __('off','dzsp'),
                    ),
                        ),array('class' => 'styleme','def_value' => ''));
                ?>
                <div class="clear"></div>
            </div>




            <div class="dzs-setting">
                <h4><?php echo __('Meta Area Links To....','dzsp'); ?></h4>
                <?php
                $lab = 'dzsp_link_metaarea';
                echo $this->misc_generate_select($lab,get_post_meta($post->ID,$lab,true),array(
                    array(
                        'value' => 'item',
                        'label' => __('Item URL','dzsp'),
                    ),
                    array(
                        'value' => 'bigimage',
                        'label' => __('Big Image','dzsp'),
                    ),
                    array(
                        'value' => 'content_opener',
                        'label' => __('Excerpt Open','dzsp'),
                    ),
                    array(
                        'value' => 'customlink',
                        'label' => __('Custom Link','dzsp'),
                    ),
                    array(
                        'value' => 'none',
                        'label' => __('Nowhere','dzsp'),
                    ),
                        ),array('class' => 'styleme','def_value' => ''));
                ?>
                <div class="clear"></div>
                <div class='sidenote'><?php echo __('Choose where clicking the featured area should go. You can input the custom link below.','dzsp'); ?></div>
                <div class="clear"></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Title Links To....','dzsp'); ?></h4>
                <?php
                $lab = 'dzsp_link_title';
                echo $this->misc_generate_select($lab,get_post_meta($post->ID,$lab,true),array(
                    array(
                        'value' => 'none',
                        'label' => __('Nowhere','dzsp'),
                    ),
                    array(
                        'value' => 'item',
                        'label' => __('Item URL','dzsp'),
                    ),
                    array(
                        'value' => 'content_opener',
                        'label' => __('Excerpt Open','dzsp'),
                    ),
                    array(
                        'value' => 'customlink',
                        'label' => __('Custom Link','dzsp'),
                    ),
                        ),array('class' => 'styleme','def_value' => ''));
                ?>
                <div class="clear"></div>
                <div class='sidenote'><?php echo __('Choose where clicking the item area should go. Default - no link on title. You can input the custom link below. A Meta Area link will overwrite this ( as title is included in meta area )  ','dzsp'); ?></div>
                <div class="clear"></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Links open in','dzsp'); ?></h4>
                <?php
                $lab = 'dzsp_link_target';
                echo $this->misc_generate_select($lab,get_post_meta($post->ID,$lab,true),array(
                    array(
                        'value' => 'self',
                        'label' => __('Same Window','dzsp'),
                    ),
                    array(
                        'value' => 'blank',
                        'label' => __('New Tab','dzsp'),
                    ),
                ),array('class' => 'styleme','def_value' => ''));
                ?>
                <div class="clear"></div>
                <div class='sidenote'><?php echo __('Choose where clicking the item area should go. Default - no link on title. You can input the custom link below. A Meta Area link will overwrite this ( as title is included in meta area )  ','dzsp'); ?></div>
                <div class="clear"></div>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Custom Link','dzsp'); ?></h4>
                <?php
                $lab = 'dzsp_customlink';
                echo $this->misc_input_text($lab,array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,$lab,true)));
                ?>
            </div>
            <div class="dzs-setting">
                <h4><?php echo __('Title Extra Classes','dzsp'); ?></h4>
                <?php
                $lab = 'dzsp_item_meta_extra_classes';
                echo $this->misc_input_text($lab,array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,$lab,true)));
                ?>
            </div>

            <div class="dzstoggle toggle1" rel="">
                <div class="toggle-title" style=""><?php echo __("Skin Blog Settings"); ?></div>
                <div class="toggle-content">

                    <div class="dzs-setting">
                        <h4><?php echo __('Top Overlay Initial Position','dzsp'); ?></h4>
                        <?php echo $this->misc_input_text('dzsp_infometa_top',array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,'dzsp_infometa_top',true))); ?>
                        <div class='sidenote'><?php echo __('set the overlay initial top position ( only for skin-blog )','dzsp'); ?></div>
                    </div>
                    <div class="dzs-setting">
                        <h4><?php echo __('Top Overlay Final Position','dzsp'); ?></h4>
                        <?php
                        $lab = 'dzsp_infometa_final_top';
                        echo $this->misc_input_text($lab,array('class' => '','def_value' => '','seekval' => get_post_meta($post->ID,$lab,true))); ?>
                        <div class='sidenote'><?php echo __('set the overlay final top position ( only for skin-blog )','dzsp'); ?></div>
                    </div>

                </div>
            </div>

        </div>

        <?php
        wp_enqueue_script('dzs.toggle',$this->thepath.'libs/dzstoggle/dzstoggle.js');
        wp_enqueue_style('dzs.toggle',$this->thepath.'libs/dzstoggle/dzstoggle.css');
    }

    function admin_meta_save($post_id) {
        global $post;
        if (!$post) {
            return;
        }
        if (isset($post->post_type) && !($post->post_type == 'dzs_portfolio' || $post->post_type == 'post')) {
            return $post_id;
        }
        /* Check autosave */
        if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
            return $post_id;
        }
        if (isset($_REQUEST['dzs_nonce'])) {
            $nonce = $_REQUEST['dzs_nonce'];
            if (!wp_verify_nonce($nonce,'dzs_nonce'))
                wp_die('Security check');
        }
        if (is_array($_POST)) {
            $auxa = $_POST;
            foreach ($auxa as $label => $value) {

                //print_r($label); print_r($value);
                if (strpos($label,'dzsp_') !== false) {
                    dzs_savemeta($post->ID,$label,$value);
                }
            }
        }
    }

    function handle_admin_head() {
        if (is_admin()) {
            echo '<script>
var dzsp_settings = {
    thepath : "'.$this->thepath.'"
    ,the_url : "'.$this->thepath.'"
    ,site_url : "'.site_url().'"
    ,translate_add_zoomfolio : "'.__("Add Zoomfolio").'"
    ,version: "'.DZSP_VERSION.'"
    ,shortcode_generator_url: "'.admin_url('admin.php?page='.$this->adminpagename_mainoptions) . '&dzsp_shortcode_builder=on'.'"';
     if(isset($_GET['sel']) && $_GET['sel']){
         echo ',startSetup:"'.$_GET['sel'].'"';
     }

echo '};
jQuery(document).ready(function($){';

        if (isset($this->db_mainoptions['use_external_uploaddir']) && $this->db_mainoptions['use_external_uploaddir'] == 'on') {
            echo "window.dzs_upload_path = '".site_url('wp-content')."/upload/';
";
            echo "window.dzs_phpfile_path = '".site_url('wp-content')."/upload.php';
";
        } else {
            echo "window.dzs_upload_path = '".$this->thepath."admin/upload/';
";
            echo "window.dzs_phpfile_path = '".$this->thepath."admin/upload.php';
";
        }
    echo 'if(typeof(window.dzsuploader_single_init)!="undefined"){
    window.dzsuploader_single_init(".dzs-single-upload",{});
}
                $("body").zoomBox({
                    settings_disableSocial : "on"
                    ,settings_deeplinking : "off"
                })
});
</script>';
            if(isset($_GET['dzsp_shortcode_builder'])==false) {
                wp_enqueue_script('dzsp_configreceiver', $this->base_url . 'tinymce/receiver.js');
            }
//            wp_enqueue_script('',$this->thepath.'tinymce/receiver.js');
        }
    }

    function handle_admin_notices() {
        //print_r($this->notices);
        foreach ($this->notices as $notice) {
            echo $notice;
        }
    }

    function handle_wp_head() {
        echo '<script>';
        echo 'window.dzsp_settings = {';
        if ($this->db_mainoptions['keyword_all']) {
            echo 'settings_categories_strall : "'.$this->db_mainoptions['keyword_all'].'"';
        }

        echo '}; ';

        $translate_close = __("Close");
        if($this->db_mainoptions['dzsp_translate_close']){

            $translate_close = $this->db_mainoptions['dzsp_translate_close'];
        }
        echo ' window.dzsp_translate_close = "'.$translate_close.'";';

        echo '</script>';
        if (isset($this->db_mainoptions['extra_css']) && $this->db_mainoptions['extra_css'] != '') {
            echo '<style>';
            echo $this->db_mainoptions['extra_css'];
            echo '</style>';
        }



        if(isset($_GET['dzsp_preview']) && $_GET['dzsp_preview']=='on') {

//            echo '$_GET[\'shortcode\'] - '.$_GET['shortcode']."\n\n";
            ?>
            <style>
                body {
                    opacity: 0;
                }

                body.ready {
                    opacity: 1;
                }

                body > * {
                    display: none;
                }

                body > .dzsp-preview-con {
                    display: block;
                }
            </style><?php
        }
    }

    function handle_footer() {

        global $post;


        if(isset($_GET['dzsp_preview']) && $_GET['dzsp_preview']=='on'){

//            echo '$_GET[\'shortcode\'] - '.$_GET['shortcode']."\n\n";
            ?>

            <?php

            if(isset($_GET['params'])){

                $params = json_decode($_GET['params']);
                ?>

                <div class="dzsp-preview-con"><?php echo $this->show_shortcode(array()); ?></div>
                <?php
            }

            if(isset($_GET['shortcode'])){

                ?>

                <div class="dzsp-preview-con"><?php echo do_shortcode(stripslashes($_GET['shortcode'])) ?></div>
                <?php
            }
            ?>

            <script>jQuery(document).ready(function($){
                    $('body').addClass('dzsp-preview ready');

                })</script>
            <?php
        }

        if (!$post) {
            return;
        }

        if ($this->fullscreen_cache_args == '') {
            return;
        }



        //echo 'ceva';

        if (is_array($this->fullscreen_cache_args)) {
            $this->fullscreen_cache_args['fullscreen'] = 'justdoit';
            echo $this->show_shortcode($this->fullscreen_cache_args);
        }


    }

    function admin_page() {
        ?>
        <div class="wrap">
        </div>
        <?php
    }

    function front_scripts() {

        wp_enqueue_script('dzs.portfolio',$this->thepath.'dzsportfolio/dzsportfolio.js');
        wp_enqueue_style('dzs.portfolio',$this->thepath.'dzsportfolio/dzsportfolio.css');
        wp_enqueue_script('jquery.isotope',$this->thepath.'dzsportfolio/jquery.isotope.min.js');
        wp_enqueue_script('dzs.advancedscroller',$this->thepath.'advancedscroller/plugin.js');
        wp_enqueue_style('dzs.advancedscroller',$this->thepath.'advancedscroller/plugin.css');
        wp_enqueue_script('dzs.zoombox',$this->thepath.'zoombox/zoombox.js');
        wp_enqueue_style('dzs.zoombox',$this->thepath.'zoombox/zoombox.css');
        wp_enqueue_script('dzs.vplayer',$this->thepath."videogallery/vplayer.js");
        wp_enqueue_style('dzs.vplayer',$this->thepath.'videogallery/vplayer.css');
    }

    function sanitize_object_value($arg){
        $fout = $arg;

        $fout = str_replace('<wbr />','',$fout);

        return $fout;
    }

    function show_shortcode($atts) {
        //[zoomfolio]
        $fout = '';

        $taxonomy = 'categoryportfolio';

        $margs = array(
            'settings_wpqargs' => '',
            'width' => '940',
            'height' => '300',
            'type' => 'bannerrotator',
            'menu_position' => 'right',
            'settings_mode' => 'masonry',
            'design_item_width' => '280',
            'design_item_height' => 'auto',
            'design_item_height_same_as_width' => 'off',
            'design_thumbw' => '',
            'design_thumbh' => '',
            'settings_posttype' => 'default',
            'design_categories_pos' => 'top',
            'menuitem_height' => '70',
            'settings_disablecats' => 'off',
            'settings_ajax' => 'off',
            'skin' => 'skin-default',
            'sortable' => 'on',
            'excerptlen' => '300',
            'bgcolor' => 'transparent',
            'cats' => '',
            'color_main' => '',
            'link_open_in_new_tab' => 'off',
            'color_highlight' => '',
            'settings_specialgrid' => '',
            'posts_per_page' => '100',
            'settings_lightboxlibrary' => 'zoombox',
            'settings_preloadall' => 'off',
            'disable_itemmeta' => 'off',
            'fullscreen' => 'off',
            'orderby' => 'date',
            'defaultcategory' => '',
            'sort_order' => 'ASC',
            'design_categories_style' => 'normal',
            'design_pageContent_pos' => 'top',
            'settings_specialgrid_chooser_enabled' => 'off',
            'settings_extraclasses' => '',
            'settings_ajax_loadmoremethod' => 'scroll',
            'settings_mode_masonry_layout' => 'masonry',
            'design_preloader_bottom' => 'off',
            'design_total_height_full' => 'off',
            'settings_mode_masonry_layout_straightacross_setitemsoncenter' => 'off',
            'is_rtl' => 'off',
            'maxlen' => 'default',
            'settings_hide_category_all' => 'off',
            'settings_uselinksforcategories' => 'off',
            'settings_uselinksforcategories_enablehistoryapi' => 'off',
            'custom_posts_ids'=>'',
            'settings_taxonomy'=>'',
            'sliders_index'=>1,
            'skin_blog_meta_format'=>'{{metadate}}{{metatags}}{{metacomments}}{{icon-times,cf-dzsap_footer_type}}',
        );

        if (!isset($atts) || $atts == false) {
            $atts = array();
        }

        $margs = array_merge($margs,$atts);

//        print_r($margs);


        $margs['sliders_index'] = $this->sliders_index;

//        print_r($atts);
//        print_r($margs);
        //===if is set to fullscreen we pass the arguments to the fullscreen call waiting in the footer
        if ($margs['fullscreen'] == 'on') {
            $this->fullscreen_cache_args = $margs;
            return;
        }
        if ($margs['skin'] == 'skin-default' || $margs['skin'] == 'skin-corporate') {
            if ($margs['design_item_height'] == '') {
                $margs['design_item_height'] = 'auto';
            }
        }
        if ($margs['skin'] == 'skin-blog') {
            if ($margs['design_item_height'] == '') {
                $margs['design_item_height'] = '280';
            }
            if ($margs['design_thumbh'] == '') {
                $margs['design_thumbh'] = 'auto';
            }
        }





        $tw = $margs['width'];
        $th = $margs['height'];




        $this->front_scripts();

        if ($margs['settings_lightboxlibrary'] == 'prettyphoto') {
            wp_enqueue_script('jquery.prettyphoto',$this->thepath.'prettyphoto/prettyphoto.js');
            wp_enqueue_style('jquery.prettyphoto',$this->thepath.'prettyphoto/prettyphoto.css');
        }

        if ($margs['settings_mode'] == 'wall') {
            wp_enqueue_script('dzs.wall',$this->thepath.'dzswall/wall.js');
            wp_enqueue_style('dzs.wall',$this->thepath.'dzswall/wall.css');
        }

        if ($margs['settings_mode'] == 'masonry') {
            wp_enqueue_script('jquery.isotope',$this->thepath.'dzsportfolio/jquery.isotope.min.js');
        }

        if ($margs['skin'] == 'skin-blog') {
            //wp_enqueue_style('font.open.sans', 'http://fonts.googleapis.com/css?family=Open+Sans');
        }

        $settings_ajax_loadmoremethod = $margs['settings_ajax_loadmoremethod'];
        if ($margs['settings_ajax']!=='on' && $margs['settings_ajax_loadmoremethod'] == 'pages') {
            $settings_ajax_loadmoremethod = 'normal';
        }




        // -- start the LOOP
        $args_wpqargs = array();
        // -- lets parse custom wp query args
        $margs['settings_wpqargs'] = html_entity_decode($margs['settings_wpqargs']);
        parse_str($margs['settings_wpqargs'],$args_wpqargs);

//        $args_wpqargs = array('tax_query' => array(
//            array(
//                'taxonomy' => 'dzsvideo_category',
//                'field'    => 'tag_id',
//                'terms'    => array( 11 ),
//            ),
//        ));
//
//        echo http_build_query($args_wpqargs);


        $margs['design_categories_style']=$this->sanitize_object_value($margs['design_categories_style']);
        $margs['settings_lightboxlibrary']=$this->sanitize_object_value($margs['settings_lightboxlibrary']);
        $margs['settings_ajax_loadmoremethod']=$this->sanitize_object_value($margs['settings_ajax_loadmoremethod']);
        $margs['settings_mode_masonry_layout']=$this->sanitize_object_value($margs['settings_mode_masonry_layout']);

        $wpqargs = array(
            'post_type' => 'dzs_portfolio',
            'posts_per_page' => '100',
        );

        if (!isset($args_wpqargs) || $args_wpqargs == false || is_array($args_wpqargs) == false) {
            $args_wpqargs = array();
        }
        $wpqargs = array_merge($wpqargs,$args_wpqargs);


        $pageNumber = (get_query_var('paged')) ? get_query_var('paged') : 1;
        $wpqargs['paged'] = $pageNumber;

        //print_r($atts);
        if (isset($atts['posts_per_page']) && $atts['posts_per_page'] > 0) {
            //print_r($atts);
            $wpqargs['posts_per_page'] = $margs['posts_per_page'];
        }
        if ($margs['settings_posttype'] != '' && $margs['settings_posttype'] != 'default') {
            //print_r($atts);
            $wpqargs['post_type'] = $margs['settings_posttype'];
        }
        //print_r($wpqargs);
        $thecustomcats = array();
        $original_thecustomcats = $thecustomcats;
        //=======custom categories
        if ($margs['cats'] != '') {

            //$wpqargs['cat'] = $margs['cats'];
            $thecustomcats = explode(',',$margs['cats']);
            $original_thecustomcats = $thecustomcats;

            if (isset($_GET['dzsp_defCategory_port'.$margs['sliders_index']]) && $margs['settings_uselinksforcategories'] == 'on' && $margs['settings_uselinksforcategories_enablehistoryapi'] != 'on' && count($thecustomcats) > 1) {
                $nr_selected_cat = $_GET['dzsp_defCategory_port'.$margs['sliders_index']];
                $nr_selected_cat = (int)$nr_selected_cat;
                $nr_selected_cat--;


                $ij = 0;
                $len = count($thecustomcats);
                for ($ij = 0; $ij < $len; $ij++) {
                    if ($ij != $nr_selected_cat) {
                        unset($thecustomcats[$ij]);
                    }
                }

                $thecustomcats = array_values($thecustomcats);

//                print_r($original_thecustomcats);
            }


                if($margs['settings_taxonomy'] && $margs['settings_taxonomy']!='default'){
                    $taxonomy = $margs['settings_taxonomy'];
                }
                $wpqargs['tax_query'] = array(
                    array(
                        'taxonomy' => $taxonomy,
                        'field' => 'id',
                        'terms' => $thecustomcats,
                    )
                );

        }
        //=======custom categories END

        if ($margs['orderby']) {
            $wpqargs['orderby'] = $margs['orderby'];
            if ($margs['orderby'] == 'meta order') {
                $wpqargs['orderby'] = 'meta_value_num';
                $wpqargs['meta_key'] = 'dzsp_meta_order';

                //$wpqargs['meta_query'] = array(array('key' => ''));
            }
            if ($margs['orderby'] == 'random') {
                $wpqargs['orderby'] = 'rand';

//                print_r($wpqargs);
                //$wpqargs['meta_query'] = array(array('key' => ''));
            }
        }
        if ($margs['sort_order'] != '') {
            $wpqargs['order'] = $margs['sort_order'];
        }

        //print_r($wpqargs);
        if ($wpqargs['post_type'] == 'post') {
            $taxonomy = 'category';
        }
        if($margs['settings_taxonomy']){
            $taxonomy = $margs['settings_taxonomy'];
        }

        //echo urlencode(json_encode($wpqargs));
        //$wpqargs['paged']=2;

        if (isset($_GET['dzsp_paged'])) {
            $wpqargs['paged'] = $_GET['dzsp_paged'];
        }
//        print_r($wpqargs);




        $post_sets = array();
        $final_rand_arr = array();
        $final_rand_arr_all = array();
        $final_rand_max_pages = 0;
        if($margs['orderby']=='random'){

            $posts_per_page_initial = intval($wpqargs['posts_per_page']);

            $wpqargs2 = array_merge(array(), $wpqargs);
            $wpqargs2['posts_per_page'] = -1;
            $wpqargs2['orderby'] = 'rand';
            $query2 = new WP_Query($wpqargs2);
//            print_r($query2);
//            echo count($query2->posts);

            $i6 = 0;


            $len_page_groups = ceil(count($query2->posts)/$posts_per_page_initial);
            $final_rand_max_pages = $len_page_groups;

            for($i20 = 0;$i20<count($query2->posts);$i20++){
                array_push($final_rand_arr_all, $query2->posts[$i20]->ID);
            }

            for($i5 = 0;$i5<$len_page_groups; $i5++){


                $auxarr = array();

                for($i_aux = 0;$i_aux<$posts_per_page_initial;$i_aux++){

                    if(isset($query2->posts[$i6])){

                        array_push($auxarr, $query2->posts[$i6]->ID);
                    }

                    $i6++;
                }

                array_push($final_rand_arr, $auxarr);

            }

//            print_r($final_rand_arr_all);




        }


        if(count($final_rand_arr)>0){
            $wpqargs['post__in'] = $final_rand_arr[0];
        }

        if(count($final_rand_arr_all)>0){

            $wpqargs['post__in'] = $final_rand_arr_all;
            $wpqargs['paged'] = '1';
            $wpqargs['orderby']='post__in';
        }


        if($margs['custom_posts_ids']){
            $aux_arr_23 = array();
            parse_str($margs['custom_posts_ids'], $aux_arr_23);
            $wpqargs['post__in'] = $aux_arr_23;
        }

        $query = new WP_Query($wpqargs);
        //print_r($query->max_num_pages);
//        print_r($query);


        $its = $query->posts;

//        print_r($query);

        if ($margs['color_main'] != '' || $margs['color_highlight']) {
            $fout.='<style class="custom-dzsp-styling">';
            if ($margs['color_main'] != '') {
                $fout.=' #port'.$margs['sliders_index'].', #port'.$margs['sliders_index'].' a { color: '.$margs['color_main'].'; }';
            }
            if ($margs['color_highlight'] != '') {
                $fout.=' #port'.$margs['sliders_index'].' .portitem:hover .the-title,
                    #port'.$margs['sliders_index'].' .selector-con .categories .a-category.active { color: '.$margs['color_highlight'].'; }';
            }
            $fout.='</style>';
            $fout.="\n";
        }



        $fout.='<div id="port'.$margs['sliders_index'].'" class="dzsportfolio';
        if ($margs['sortable'] == 'on') {
            $fout.=' is-sortable';
        } else {
            $fout.=' is-not-sortable';
        }
        if ($margs['fullscreen'] == 'justdoit') {
            $fout.=' portfolio-is-fullscreen';
        }
        if ($margs['settings_specialgrid'] != '' && $margs['settings_specialgrid'] != 'none') {
            // echo 'ceva' . $margs['settings_specialgrid'];
            $fout.=' '.$margs['settings_specialgrid'];
            $margs['design_item_width'] = "";
        }
        $fout.=' '.$margs['skin'];
        $fout.= ' '.$margs['settings_extraclasses'];
        $fout.='" style="';
        if($margs['bgcolor']!=''){
            $fout.=' background-color: '.$margs['bgcolor'].'';
        }


        $fout.='">';
        $fout.='<div class="items">';
        $fout.=$this->parse_items($its,$margs,$wpqargs);
        $fout.='</div>';




        $fout.='<div class="preloader';
        if ($margs['design_preloader_bottom'] == 'on') {
            $fout.=' bottom';
        }

        $fout.='"></div>';
        $fout.='</div>';


        if ($margs['settings_ajax']!=='on'&& $margs['settings_ajax_loadmoremethod'] == 'pages') {
            if ($query->max_num_pages > 1) {
                //
                $fout.='<div class="con-dzsp-pagination">';
                for ($ip = 0; $ip < $query->max_num_pages; $ip++) {

                    $fout.='<a href="'.add_query_arg('dzsp_paged',($ip + 1),dzs_curr_url()).'" class="dzsp-pagination-number pagination-number';
                    if (isset($_GET['dzsp_paged'])) {
                        if ($_GET['dzsp_paged'] == ($ip + 1)) {
                            $fout.=' active';
                        }
                    } else {
                        if ($ip == 0) {
                            $fout.= ' active';
                        }
                    }
                    $fout.='">'.($ip + 1).'</a>';
                }
                $fout.='</div>';
            }
        }

        $jreadycall = 'jQuery(document).ready(function($){';

        if (isset($margs['wall_settings_thumbs_per_row']) && $margs['wall_settings_thumbs_per_row'] != '') {

        } else {
            $margs['wall_settings_thumbs_per_row'] = 5;
        }

        if ($margs['fullscreen'] == 'justdoit') {
            $fout.='<div class="wall-close" style="z-index: 50006">'.__("CLOSE PORTFOLIO").'</div>';
        }


        $fout.='<script>';

        if ($margs['fullscreen'] == 'justdoit') {
            $fout.='var dzsp_videofs = true; ';
        }
        $fout.=$jreadycall; ///====jQuery document ready
        if ($margs['is_rtl'] == 'on') {
            $fout.='$.Isotope.prototype._positionAbs = function( x, y ) {
    return { right: x, top: y };
}; ';
            //$("body").attr("dir", "rtl");
        }
        if ($margs['settings_mode'] == 'wall') {
            $fout.='var wall_settings = {
    settings_thumbs_per_row:"'.$margs['wall_settings_thumbs_per_row'].'",
    settings_width:0,
    settings_height:0,
    thumb_width:"'.$margs['design_item_width'].'",
    thumb_height:"'.$margs['design_item_height'].'",
    thumb_space:"'.$margs['wall_thumb_space'].'"
};';
        }
        if ($margs['fullscreen'] == 'justdoit') {
            $fout.='jQuery(".wall-close").click(handle_wall_close);
        function handle_wall_close(){
var _t = jQuery(this);
if(dzsp_videofs==true){
    _t.html("OPEN PORTFOLIO");
    jQuery(".portfolio-is-fullscreen").fadeOut("slow");
    jQuery("body > .cat-selector").fadeOut("slow");
    dzsp_videofs = false;
}else{
    _t.html("CLOSE PORTFOLIO");
    jQuery(".portfolio-is-fullscreen").fadeIn("slow");
    jQuery("body > .cat-selector").fadeIn("slow");
    dzsp_videofs = true;
}
}';
        }



        if ($margs['settings_mode'] == 'masonry' && $margs['settings_mode_masonry_layout'] == 'straightAcross') {
            wp_enqueue_script('dzs.scroller',$this->thepath.'dzsscroller/scroller.js');
            wp_enqueue_style('dzs.scroller',$this->thepath.'dzsscroller/scroller.css');
        }


//        print_r($margs);
        $fout.=' 
window.dzsp_init("#port'.$margs['sliders_index'].'",{
settings_slideshowTime:3
,settings_mode: "'.$margs['settings_mode'].'"
,title: ""
,design_item_width: "'.$margs['design_item_width'].'"
,design_item_height: "'.$margs['design_item_height'].'"
,design_categories_style: "'.$margs['design_categories_style'].'"
,design_categories_pos: "'.$margs['design_categories_pos'].'"
,design_pageContent_pos: "'.$margs['design_pageContent_pos'].'"
,settings_disableCats: "'.$margs['settings_disablecats'].'"
,settings_lightboxlibrary: "'.$margs['settings_lightboxlibrary'].'"
,settings_preloadall: "'.$margs['settings_preloadall'].'"
,audioplayer_swflocation: "'.$this->thepath.'ap.swf"
,videoplayer_swflocation: "'.$this->thepath.'preview.swf"
,disable_itemmeta: "'.$margs['disable_itemmeta'].'"
,settings_image_hide_source: "'.$this->db_mainoptions['settings_image_hide_source'].'"
,settings_ajax_loadmoremethod: "'.$settings_ajax_loadmoremethod.'"
,settings_useLinksForCategories : "'.$margs['settings_uselinksforcategories'].'"
,settings_useLinksForCategories_enableHistoryApi : "'.$margs['settings_uselinksforcategories_enablehistoryapi'].'"
,settings_mode_masonry_layout: "'.$margs['settings_mode_masonry_layout'].'"
,design_total_height_full: "'.$margs['design_total_height_full'].'"
,settings_mode_masonry_layout_straightacross_setitemsoncenter: "'.$margs['settings_mode_masonry_layout_straightacross_setitemsoncenter'].'"
,design_item_height_same_as_width : "'.$margs['design_item_height_same_as_width'].'"';

        if($margs['skin']=='skin-arizona'){
            $fout.=',ajax_for_likes:"'.site_url().'/index.php"';
        }
        if ($margs['cats'] != '') {
            $fout.=',settings_forceCats:[';
            //echo 'hmmdada';
            $iaux = 0;
            foreach ($original_thecustomcats as $customcatid) {
                //print_r($customcat);
                $customcat = get_term($customcatid,$taxonomy);
                if (isset($customcat->name)) {
                    //print_r($customcat);
                    if ($iaux > 0) {
                        $fout.=',';
                    }

                    $aux = $customcat->name;
                    $aux = str_replace('"','',$aux);

                    $fout.='"'.$aux.'"';
                    $iaux++;
                }
            }
            $fout.=']';
            $fout.=',settings_forceCats_ids:[';
            //echo 'hmmdada';
            $iaux = 0;
            foreach ($original_thecustomcats as $customcatid) {
                //print_r($customcat);
                $customcat = get_term($customcatid,$taxonomy);
                if (isset($customcat->name)) {
                    //print_r($customcat);
                    if ($iaux > 0) {
                        $fout.=',';
                    }

                    $aux = $customcat->term_id;
                    $aux = str_replace('"','',$aux);

                    $fout.='"'.$aux.'"';
                    $iaux++;
                }
            }
            $fout.=']';
        }
        if ($margs['defaultcategory'] != '') {

            $auxcat = get_term($margs['defaultcategory'],$taxonomy);

            $fout.=' ,settings_defaultCat:"'.$auxcat->name.'"';
        }
        if ($margs['settings_hide_category_all'] == 'on') {
            $fout.=',settings_categories_strall:""';
        }



        if ($margs['design_thumbw'] != '') {
            $fout.=',design_thumbw:"'.$margs['design_thumbw'].'"';
        }
        if ($margs['design_thumbh'] != '') {
            $fout.=',design_thumbh:"'.$margs['design_thumbh'].'"';
        }
        if ($margs['settings_specialgrid_chooser_enabled'] == 'on') {
            $fout.=',settings_specialgrid_chooser: ["special-grid-4","special-grid-5"]';
        }



        if($final_rand_max_pages==0){
            $final_rand_max_pages = $query->max_num_pages;
        }

        if ($margs['settings_ajax'] == 'on' && $query->max_num_pages > 1) {
            $fout.=',settings_ajax_enabled:"on"';
            $fout.=',settings_ajax_pages:[';
            for ($i = 1; $i < $query->max_num_pages; ++$i) {
                if ($i > 1) {
                    $fout.=',';
                }
                $aux_wpqargs = array_merge(array(), $wpqargs);
                if (isset($aux_wpqargs['paged'])) {

                }


                $aux_margs= array_merge(array(), $margs);

                if($margs['orderby']=='random'){
//                    $aux_wpqargs['custom_posts_ids'] = http_build_query($final_rand_arr_all);
                    $aux_wpqargs['post__in'] = $final_rand_arr_all;
                    $aux_wpqargs['paged'] = $i+1;
                    $aux_wpqargs['orderby']='post__in';
//                    $aux_wpqargs['paged']='1';
                }

                $fout.='"'.$this->thepath.'ajaxreceiver.php?wpqargs='.urlencode(json_encode($aux_wpqargs)).'&args='.urlencode(json_encode($aux_margs)).'&paged='.($i + 1).'"';
            }
            $fout.=']';
        }
        if ($margs['is_rtl'] == 'on') {
            $fout.=',settings_isotope_settings: {transformsEnabled: false}';
        }

        $fout.=',zoombox_settings: { settings_disablezoom: "'.$this->db_mainoptions['zoombox_settings_disablezoom'].'", settings_zoom_doNotGoBeyond1X: "'.$this->db_mainoptions['zoombox_settings_zoom_donotgobeyond1x'].'"';



        if($this->db_mainoptions['zoombox_settings_video_autoplay']){
            $fout.=',videoplayer_settings: { zoombox_video_autoplay: "'.$this->db_mainoptions['zoombox_settings_video_autoplay'].'" }';
        }

    $fout.='}';
        $fout.='})
});
</script>';





        $this->sliders_index++;
        return $fout;
    }

    public function parse_items($its,$pargs,$wpqargs) {
        //echo 'ceva';
        $fout = '';
        $taxonomy = 'categoryportfolio';


        $margs = array(
            'try_repair'=>'default',
            'settings_excerpt_len'=>'all',
            'strip_html'=>'default',
            'strip_shortcodes'=>'default',
        );

        $margs = array_merge($margs, $pargs);


        $thecustomcats = array();
//        print_r($margs);
        //=======custom categories
        if ($margs['cats'] != '') {
            $thecustomcats = explode(',',$margs['cats']);
        }

        for ($i = 0; $i < count($its); $i++) {
            //print_r($its[$i]);
            $iout = '';
            $che = $its[$i];
//            echo get_the_ID(); print_r($che);

            // --- stabilizing meta
            $the_id = $che->ID;
            $the_link = get_permalink($the_id); //== the link to the actual item
            $the_type = 'thumb';

            if($the_id===get_the_ID()){
                continue;
            }


            $try_repair = false;

            if($margs['strip_shortcodes']=='off'){

                $aux_stripshortcodes = false;
            }

            if($margs['strip_shortcodes']=='on'){

                $aux_stripshortcodes = true;
            }
            if($margs['strip_shortcodes']=='default'){

                $aux_stripshortcodes = true;
            }

            if($margs['strip_html']=='off'){

                $striptags = false;
            }

            if($margs['strip_html']=='on'){

                $striptags = true;
            }
            if($margs['try_repair']=='off'){

                $try_repair = false;
            }

            if($margs['try_repair']=='on'){

                $try_repair = true;
            }
            if($margs['strip_html']=='default'){

                $striptags = true;
            }


            $meta_disable_title_subtitle = get_post_meta($the_id,'dzsp_disable_title_subtitle',true);
            $meta_disable_content = get_post_meta($the_id,'dzsp_disable_content',true);
            $meta_biggallery = get_post_meta($the_id,'dzsp_biggallery',true);

            $meta_image_gallery = get_post_meta($the_id,'dzsp_image_gallery',true);
            $meta_image_gallery_images = explode(',',$meta_image_gallery);

            if (get_post_meta($the_id,'dzsp_item_type',true) != '') {
                $the_type = get_post_meta($the_id,'dzsp_item_type',true);
            }


            if ($the_type == 'thumb') {
                if ($meta_image_gallery != '') {
                    $meta_biggallery = 'gallery-for-item-'.$the_id;
                }
            }

            if ($the_type == 'link') {
                $the_link = get_post_meta($the_id,'dzsp_featured_media',true);
            }


            if (($margs['skin'] == 'skin-accordion' || $margs['skin'] == 'skin-clean') && ($the_type == 'video' || $the_type == 'youtube' || $the_type == 'vimeo' || $the_type == 'gallery' || $the_type == 'audio' || $the_type == 'testimonial')) {
                $meta_disable_content = 'on';
                $meta_disable_title_subtitle = 'on';
            }

            //===== setting up links START / setup links

            $link_type_featuredmedia = get_post_meta($the_id,'dzsp_link_featurearea',true);
            $link_featuredmedia = get_post_meta($the_id,'dzsp_big_image',true);
            //dzsp_link_featurearea
            if (get_post_meta($the_id,'dzsp_link_featurearea',true) == 'item') {
                $link_featuredmedia = $the_link;
            }
            if (get_post_meta($the_id,'dzsp_link_featurearea',true) == 'customlink') {
                $link_featuredmedia = get_post_meta($the_id,'dzsp_customlink',true);
            }
            if (get_post_meta($the_id,'dzsp_link_featurearea',true) == 'content_opener') {
                $link_featuredmedia = 'content_opener';
            }
            if (get_post_meta($the_id,'dzsp_link_featurearea',true) == 'none') {
                $link_featuredmedia = '';
            }

            $link_type_metaarea =  get_post_meta($the_id,'dzsp_link_metaarea',true);
            $link_metaarea = $the_link;
            //dzsp_link_featurearea
            if (get_post_meta($the_id,'dzsp_link_metaarea',true) == 'bigimage') {
                $link_metaarea = get_post_meta($the_id,'dzsp_big_image',true);
            }
            if (get_post_meta($the_id,'dzsp_link_metaarea',true) == 'customlink') {
                $link_metaarea = get_post_meta($the_id,'dzsp_customlink',true);
            }
            if (get_post_meta($the_id,'dzsp_link_metaarea',true) == 'content_opener') {
                $link_metaarea = 'content_opener';
            }
            if (get_post_meta($the_id,'dzsp_link_metaarea',true) == 'none') {
                $link_metaarea = '';
            }



            $link_title = '';
            //dzsp_link_featurearea
            if (get_post_meta($the_id,'dzsp_link_title',true) == 'item') {
                $link_title = $the_link;
            }
            if (get_post_meta($the_id,'dzsp_link_title',true) == 'customlink') {
                $link_title = get_post_meta($the_id,'dzsp_customlink',true);
            }
            if (get_post_meta($the_id,'dzsp_link_title',true) == 'none') {
                $link_title = '';
            }

//            echo $the_id . ' -- link title -- ('.get_post_meta($the_id,'dzsp_link_title',true).') - '.$link_title.' [[ link metaarea - '.$link_metaarea.']] <-- ||| ';

            if($link_metaarea!=''){
                if($margs['skin']!='skin-blog'){

                    $link_title = '';
                }
            }

//            echo ' cevava '.$the_id.' '.get_post_meta($the_id,'dzsp_link_metaarea',true).' | '.$link_metaarea;

            $str_item_w = '';
            $aux = get_post_meta($the_id,'dzsp_force_width',true);
            if ($aux != '') {
                $str_item_w.=' width:';
                if (strpos($aux,"%") === false && strpos($aux,"auto") === false && strpos($aux,"px") === false) {
                    $str_item_w.=$aux.'px';
                } else {
                    $str_item_w.=$aux;
                }
                $str_item_w.=';';
            }

            $str_item_h = '';
            $aux = get_post_meta($the_id,'dzsp_force_height',true);
            if ($aux != '') {
                $str_item_h.=' height:';
                if (strpos($aux,"%") === false && strpos($aux,"auto") === false && strpos($aux,"px") === false) {
                    $str_item_h.=$aux.'px';
                } else {
                    $str_item_h.=$aux;
                }
                $str_item_h.=';';
            }

            $str_thumb_w = '';
            $aux = get_post_meta($the_id,'dzsp_force_thumb_width',true);
            if ($aux != '') {
                $str_thumb_w.=' width:';
                if (strpos($aux,"%") === false && strpos($aux,"auto") === false && strpos($aux,"px") === false) {
                    $str_thumb_w.=$aux.'px';
                } else {
                    $str_thumb_w.=$aux;
                }
                $str_thumb_w.=';';
            }

            $str_thumb_h = '';
            $aux = get_post_meta($the_id,'dzsp_force_thumb_height',true);
            if ($aux != '') {
                $str_thumb_h.=' height:';
                if (strpos($aux,"%") === false && strpos($aux,"auto") === false && strpos($aux,"px") === false) {
                    $str_thumb_h.=$aux.'px';
                } else {
                    $str_thumb_h.=$aux;
                }
                $str_thumb_h.=';';
            }


            $the_subtitle = get_post_meta($the_id,'dzsp_subtitle',true);
            if ($the_subtitle == '' && ($margs['skin'] == 'skin-default' || $margs['skin'] == 'skin-zero') && $che->post_excerpt) {
                $the_subtitle = $che->post_excerpt;
            }


            $post_terms = array();

            if ($wpqargs['post_type'] == 'product') {

                $taxonomy = 'product_cat';
            }

            if ($wpqargs['post_type'] == 'courses') {

                $taxonomy = 'course_categories';
            }
            if ($wpqargs['post_type'] == 'post') {

                $taxonomy = 'category';
            }

            if($margs['settings_taxonomy']) {
                $taxonomy = $margs['settings_taxonomy'];
            }



            $post_terms = wp_get_post_terms($the_id,$taxonomy,array("fields" => "all"));


            //print_r($post_terms);
            //=== needs improving, zoomit - now i think it does not
            $design_item_width = $margs['design_item_width'];
            $design_item_height = $margs['design_item_height']; // -- design_item_height was set in the
            if ($design_item_height == '' || $design_item_height == 'auto') {
                $design_item_height = 200;
            }
            //==temp solution
//            echo $design_item_width; echo $design_item_height; echo 'design';
	        $the_src = '';
            if ($this->db_mainoptions['thumbs_full_quality'] == 'full') {
                $the_src = wp_get_attachment_image_src(get_post_thumbnail_id($che->ID),'full');
            } else if ($this->db_mainoptions['thumbs_full_quality'] == 'medium') {
                $the_src = wp_get_attachment_image_src(get_post_thumbnail_id($che->ID),array(($design_item_width * 2),($design_item_height * 2)));
            } else {
                $the_src = wp_get_attachment_image_src(get_post_thumbnail_id($che->ID),array($design_item_width,$design_item_height));
            }

            //print_r($the_src);
            $thumbnail_src = $the_src[0];

            if (($this->db_mainoptions['misc_force_featured_media_over_featured_image'] == 'on' && get_post_meta($the_id,'dzsp_featured_media',true) != '') || ($thumbnail_src == '' && get_post_meta($the_id,'dzsp_featured_media',true) != '')) {
                $thumbnail_src = get_post_meta($the_id,'dzsp_featured_media',true);
            }

//            print_r($margs);

            $maxlen = 233;

            if(isset($margs['settings_excerpt_len'])){
                $maxlen = $margs['settings_excerpt_len'];
            }
            if (get_post_meta($the_id,'dzsp_excerpt_len',true) != '') {
                $maxlen = get_post_meta($the_id,'dzsp_excerpt_len',true);
            }

            if($maxlen==='all'){
                $maxlen=1234567;
            }

            $po_excerpt_content = '';


            // ----- --------   --------    --    ----------
            // ---    ----- -- start output the item ---  --
            // ----------  -------------  -     ------------

            $iout.='<div class="portitem-tobe portid'.$the_id;
            if (get_post_meta($the_id,'dzsp_extra_classes',true) != '') {
                $iout.=' '.get_post_meta($the_id,'dzsp_extra_classes',true);
            }
            $iout.='" ';



            // --- we force the youtube and vimeo to Featured Media Meta Field ( it's a id, you can't set it in Featured Image )

            $dataType = $the_type; // --datatype is the type to put int javascript
            if ($the_type == 'twitter') {
                $dataType = 'testimonial';
            }


            if ($the_type == 'youtube' || $the_type == 'vimeo' || $the_type == 'video') {
                // ---- videos
                // ------ if there is a featured image
                if ($the_src[0] != '') {
                    $iout.=' data-thumbnail="'.$the_src[0].'"';
                }
                $iout.=' data-source_video="'.get_post_meta($the_id,'dzsp_featured_media',true).'"';


	            if (get_post_meta($the_id,'dzsp_sourceogg',true) != '') {
		            $iout.=' data-source_video_ogg="'.get_post_meta($the_id,'dzsp_sourceogg',true).'"';
	            }
            } else {

                $iout.=' data-thumbnail="'.$thumbnail_src.'"';


            }


	        if ($the_type == 'audio') {

		        wp_enqueue_script('dzs.audioplayer',$this->thepath.'audioplayer/audioplayer.js');
		        wp_enqueue_style('dzs.audioplayer',$this->thepath.'audioplayer/audioplayer.css');



//	                print_r($the_src);
		        // ------ if there is a featured image
		        if ($the_src[0] != '') {
			        $iout.=' data-thumbnail="'.$the_src[0].'"';
		        }
		        $iout.=' data-source_audio="'.get_post_meta($the_id,'dzsp_featured_media',true).'"';



		        if (get_post_meta($the_id,'dzsp_sourceogg',true) != '') {
			        $iout.=' data-source_audio_ogg="'.get_post_meta($the_id,'dzsp_sourceogg',true).'"';
		        }
	        }


            if ($the_type == 'thumb' && isset($margs['settings_biggalleryall']) && $margs['settings_biggalleryall'] == 'on') {
                $iout.=' data-biggallery="'.'port1'.'"';
            } else {
                if ($the_type == 'thumb' && $meta_biggallery != '') {
                    $iout.=' data-biggallery="'.$meta_biggallery.'"';
                }
            }




            if (get_post_meta($the_id,'dzsp_open_big_image_in_lightbox',true) == 'off') {
                $iout.=' data-donotopenbigimageinzoombox="on"';
            }

            if (get_post_meta($the_id,'dzsp_highlight_color',true) != '') {
                $iout.=' data-color_highlight="'.get_post_meta($the_id,'dzsp_highlight_color',true).'"';
            }
            if (get_post_meta($the_id,'dzsp_slideshowtime',true) != '') {
                $iout.=' data-slideshowtime="'.get_post_meta($the_id,'dzsp_slideshowtime',true).'"';
            }

            $iout.=' data-link="'.$link_metaarea.'"';


            if(get_post_meta($the_id, 'dzsp_item_meta_extra_classes', true)){
                $iout.=' data-item_meta_extra_classes="'.get_post_meta($the_id, 'dzsp_item_meta_extra_classes', true).'"';
            }

            $iout.=' data-typefeaturedarea="'.$dataType.'"';

            if (get_post_meta($the_id,'dzsp_big_image',true) != '') {
                if ($margs['skin'] == 'skin-clean') {
                    $iout.=' data-bigimage="'.get_post_meta($the_id,'dzsp_big_image',true).'"';
                }else{
                    $iout.=' data-bigimage="'.$link_featuredmedia.'"';
                }

            }
            if (get_post_meta($the_id,'dzsp_force_width',true) != '') {
                $iout.=' data-forcewidth="'.get_post_meta($the_id,'dzsp_force_width',true).'"';
            }
            if (get_post_meta($the_id,'dzsp_force_height',true) != '') {
                $iout.=' data-forceheight="'.get_post_meta($the_id,'dzsp_force_height',true).'"';
            }
            if (get_post_meta($the_id,'dzsp_force_thumb_width',true) != '') {
                $iout.=' data-forcethumbwidth="'.get_post_meta($the_id,'dzsp_force_thumb_width',true).'"';
            }
            if (get_post_meta($the_id,'dzsp_force_thumb_height',true) != '') {
                $iout.=' data-forcethumbheight="'.get_post_meta($the_id,'dzsp_force_thumb_height',true).'"';
            }
            if (is_array($post_terms)) {

//                print_r($post_terms);
                $ik = 0;
                $iout.=' data-term_ids="';

                foreach ($post_terms as $post_term) {


//                    print_r($post_term); echo 'ceva'; print_r($thecustomcats);
                    //$cat
                    $auxsw = false;


//                    print_r($post_term);
                    if ($ik > 0) {
                        $iout.=';';
                    }
                    $iout.=$post_term->term_id;
//                    $post_term = str_replace('"','',$post_term);
//                    $iout.=htmlentities($post_term);
                    $ik++;
                }
                $iout.='"';



                $ik = 0;
                $iout.=' data-term_names="';

                foreach ($post_terms as $post_term) {


//                    print_r($post_term); echo 'ceva'; print_r($thecustomcats);
                    //$cat
                    $auxsw = false;

                    //print_r($thecustomcats);
                    if ($ik > 0) {
                        $iout.=';';
                    }
                    $post_term_name=$post_term->name;
                    $post_term_name = str_replace('"','',$post_term_name);
                    $iout.=$post_term_name;
//                    $iout.=htmlentities($post_term);
                    $ik++;
                }
                $iout.='"';
            }

            if ($the_type == 'youtube') {
                $iout.=' data-heroimage="'.$this->thepath.'dzsportfolio/img/hero-type-video-youtube.png"';
            }
            if ($the_type == 'vimeo') {
                $iout.=' data-heroimage="'.$this->thepath.'dzsportfolio/img/hero-type-video-vimeo.png"';
            }
            if ($the_type == 'twitter') {
                $iout.=' data-heroimage="'.$this->thepath.'dzsportfolio/img/hero-type-twitter.png"';
            }
            if ($the_type == 'link') {
                $iout.=' data-heroimage="'.$this->thepath.'dzsportfolio/img/hero-type-link.png"';
            }


            $iout.='>';

            if ($the_type == 'gallery') {
                wp_enqueue_script('dzs.advancedscroller',$this->thepath.'advancedscroller/plugin.js');
                wp_enqueue_style('dzs.advancedscroller',$this->thepath.'advancedscroller/plugin.css');
                $iout.='<div class="the-feature-data">';
                $image_gallery_meta = get_post_meta($the_id,'dzsp_image_gallery',true);
                $image_gallery_arr = explode(',',$image_gallery_meta);
                if (is_array($image_gallery_arr) && count($image_gallery_arr) > 0) {
                    foreach ($image_gallery_arr as $img) {
                        //echo ;
                        $imgsrc = wp_get_attachment_image_src($img,'full');
                        //echo $imgsrc;
                        $iout.='<img class="fullwidth" src="'.$imgsrc[0].'"/>';
                    }
                }

                $iout.='</div>';
            }
            if ($the_type == 'testimonial') {
                //echo 'ceva';
                $iout.='<div class="the-feature-data">';
                $iout.= get_post_meta($the_id,'dzsp_featured_media',true);
                $iout.='</div>';
            }
            if ($the_type == 'twitter') {
                //echo 'ceva';
                $iout.='<div class="the-feature-data">';
                include_once(dirname(__FILE__).'/twitterapiwrapper/twitterapi.php');

//==complete these with your twitter api key details
                $token = $this->db_mainoptions['twitter_token'];
                $token_secret = $this->db_mainoptions['twitter_token_secret'];
                $consumer_key = $this->db_mainoptions['twitter_consumer_key'];
                $consumer_secret = $this->db_mainoptions['twitter_consumer_secret'];

                $api1 = new TwitterAPI($token,$token_secret,$consumer_key,$consumer_secret);


                $query = array(// query parameters
                    'screen_name' => get_post_meta($the_id,'dzsp_featured_media',true),
                    'count' => '1'
                );
                $data = $api1->do_query($query);
//print_r($data);
                if (isset($data->errors)) {
                    print_r($data);
                    //echo 'ceva';
                } else {
                    $iout.= ($data[0]->text);
                }
                $iout.='</div>';
            }
            if ($the_type == 'audio') {

                wp_enqueue_script('dzs.audioplayer',$this->thepath.'audioplayer/audioplayer.js');
                wp_enqueue_style('dzs.audioplayer',$this->thepath.'audioplayer/audioplayer.css');
            }
            if ($the_type == 'video' || $the_type == 'youtube' || $the_type == 'vimeo') {

                wp_enqueue_script('dzs.vplayer',$this->thepath."videogallery/vplayer.js");
                wp_enqueue_style('dzs.vplayer',$this->thepath.'videogallery/vplayer.css');
            }


            $the_post_content = '';

            $attachments = get_children(array('post_parent' => $the_id,'post_type' => 'attachment','post_mime_type' => 'image','orderby' => 'menu_order',
                'order' => 'ASC',));
            //echo 'the post is ' . $the_id . "\n";



            $str_items = '';
            $image_gallery_meta = get_post_meta($the_id,'dzsp_image_gallery',true);
            $image_gallery_arr = explode(',',$image_gallery_meta);


            if ($image_gallery_meta != '') {
                foreach ($image_gallery_arr as $img) {
                    //echo ;
                    $imgsrcarr = wp_get_attachment_image_src($img,'full');
                    //echo $imgsrc;
                    $str_items .= '<li class="item-tobe needs-loading">
<div class="imagediv" style="background-image: url('.$imgsrcarr[0].'); height:250px;"></div>
</li>';
                }
            }



            if($maxlen===1234567){
                $striptags = false;
                $aux_stripshortcodes = false;
            }
            if ($striptags == false && isset($the_post_content_inner) && $the_post_content_inner != '' && class_exists('DOMDocument') && $maxlen!==1234567) {
                if($margs['try_repair']=='default'){
                    $try_repair = true;
                }
            }


//            print_r($margs);

            $the_post_content_inner = '';
            $the_post_content_inner.=stripslashes(DZSHelpers::wp_get_excerpt($the_id,array(
                'forceexcerpt' => false,
                'readmore' => 'auto',
                'stripshortcodes' => $aux_stripshortcodes,
                'striptags' => $striptags,
                'maxlen' => $maxlen,
                'content' => $po_excerpt_content,
                'try_repair' => $try_repair,
                'aftercutcontent_html' => ' [...]'
            )));
            $the_post_content_inner = str_replace('{link_metaarea}',$link_metaarea,$the_post_content_inner);



//                echo 'ceva'.$the_post_content_inner.'END';
            // -- we run the html through a parser to close unclosed tags

            $excerpt_gallery_slider_str = '';
            $the_project_meta_html = '';
            if ($str_items != '') {
                $excerpt_gallery_slider_str.='<div class="advancedscroller-con">
    <div class="advancedscroller skin-agata-inset" style="width:100%;"><ul class="items">';
                $excerpt_gallery_slider_str.=$str_items;
                $excerpt_gallery_slider_str.='</ul></div></div>';


                $excerpt_gallery_slider_str.='<div class="toexecute">
(function() {
var aux = window.dzsp_execute_target.find(".advancedscroller");
jQuery(document).ready(function($){
window.dzsas_init(aux,{
settings_mode: "onlyoneitem"
,design_arrowsize: "0"
,settings_swipe: "on"
,settings_swipeOnDesktopsToo: "on"
,settings_slideshow: "on"
,settings_slideshowTime: "15"
});
});
})();
</div>';
            }




            if ($che->post_excerpt != '') {
                $the_project_meta_html = $che->post_excerpt;

            } else {
                if ($excerpt_gallery_slider_str != '') {
                    $the_project_meta_html.='<div class="dzs-col-md-6">';
                    $the_project_meta_html.=$excerpt_gallery_slider_str;
                    $the_project_meta_html.='</div>';
                    $the_project_meta_html.='<div class="dzs-col-md-6';
                } else {

                    $the_project_meta_html.='<div class="dzs-col-md-12';
                }

                $try_tidy = false;

                if ($margs['skin'] == 'skin-accordion' || $margs['skin'] == 'skin-clean') {
                    $the_project_meta_html.=' project-meta-con';
                    $maxlen = 4000;
                    $try_tidy = true;
                }


                $try_tidy = true;

                if($margs['try_repair']=='off'){
                    $try_tidy = false;
                }

                $the_project_meta_html.='">';

                $excerpt_cont = stripslashes(DZSHelpers::wp_get_excerpt($the_id,array(
                    'forceexcerpt' => false,
                    'readmore' => 'auto',
                    'stripshortcodes' => false,
                    'striptags' => false,
                    'maxlen' => $maxlen,
                    'aftercutcontent_html' => ' [...]',
                    'try_repair' => $try_tidy
                )));

//                echo 'try repair - '.$try_tidy;
                $the_project_meta_html.=$excerpt_cont;
                $the_project_meta_html.='</div>';

            }

            $the_project_meta_html = str_replace('{{dzsp_gallery_slider}}', $excerpt_gallery_slider_str, $the_project_meta_html);
            $the_project_meta_html = str_replace('{{dzsp_post_link}}', get_permalink($the_id), $the_project_meta_html);

            $the_project_meta_html = preg_replace("/<!--[\\s|\\S]*?-->/", "a", $the_project_meta_html);




            $str_big_content = '';



            $str_big_content.='<div class="the-content excerpt-content" style=""><div class="dzs-colcontainer">';

            $str_big_content.=$the_project_meta_html;

            $str_big_content.='</div></div>';


//            echo 'ceva3'.$str_big_content;
//            echo $margs['skin'] . 'ceva';
            if ($margs['skin'] == 'skin-corporate') {
                $iout.='<div class="item-meta" style="margin-top: 15px;">';
            }

            //echo 'ceva23'; echo $str_items; echo $str_items!='';







            if ($margs['skin'] == 'skin-clean' || $margs['skin'] == 'skin-accordion') {
                if ($link_type_featuredmedia == 'content_opener') {
                    $iout.=$str_big_content;
                }
            }


            //echo 'hmmceva'.$the_post_content_inner.'hmmalceva';;

            $the_post_content.=$the_post_content_inner;



            //===skins which have a slider
            if ($margs['skin'] == 'skin-accordion' || $margs['skin'] == 'skin-clean') {
                $the_post_content.='</div>'; //===END skins which have a slider
            }



//            $the_post_content.='</div>'; //close row
//            echo $the_post_content;


            //==skin default and skin-nebula and skin-timeline have only title and desc
            //=== skin corporate has content but uses these too..
            if (($margs['skin'] == 'skin-timeline' || $margs['skin'] == 'skin-nebula' || $margs['skin'] == 'skin-clean' || $margs['skin'] == 'skin-corporate' || $margs['skin'] == 'skin-default' || $margs['skin'] == 'skin-zero' || $margs['skin'] == 'skin-accordion' || $margs['skin'] == 'skin-boxed' || $margs['skin'] == 'skin-aura' || $margs['skin'] == 'skin-vintage' || $margs['skin'] == 'skin-commerce') && $meta_disable_title_subtitle != 'on') {
                if ($che->post_title) {
                    $iout.='<div class="the-title">';


                    if ($link_title != '') {
                        $iout.='<a';

                        if($margs['link_open_in_new_tab']=='on'  || get_post_meta($the_id,'dzsp_link_target',true)=='blank'){
                            $iout.=' target="_blank"';
                        }

                        $iout.=' href="'.$link_title.'">';
                    }
                    $iout.=$che->post_title;
                    if ($link_title != '') {
                        $iout.='</a>';
                    }

                    $iout.='</div>';
                }

                if ($wpqargs['post_type'] == 'product' && ($margs['skin'] == 'skin-default' || $margs['skin'] == 'skin-commerce') && $the_subtitle == '') {

                    $the_subtitle = '';
                    $old_price = '';
                    $sale_price = '';
                    $old_price = get_post_meta($the_id,'_regular_price',true);
                    if (get_post_meta($the_id,'_sale_price',true)) {
                        $sale_price = get_post_meta($the_id,'_sale_price',true);
                    }

                    //--- if woo commerce enabled
                    if ($old_price && function_exists('get_woocommerce_currency_symbol')) {
                        if ($sale_price) {
                            $the_subtitle.='<div class="price"><span class="real-price">'.get_woocommerce_currency_symbol(get_woocommerce_currency()).$sale_price.'</span> <span class="old-price">'.get_woocommerce_currency_symbol(get_woocommerce_currency()).$old_price.'</span></div>';
                        } else {

                            $the_subtitle.='<div class="price"><span class="real-price">'.get_woocommerce_currency_symbol(get_woocommerce_currency()).$old_price.'</span></div>';
                        }

                        $the_subtitle .= '
<div class="addtocart-con">';
                        if ($margs['skin'] == 'skin-default') {
                            $the_subtitle.='<div class="button-addtocart">';
                        }
                        if ($margs['skin'] == 'skin-commerce') {
                            $the_subtitle.='<div class="addtocart-btn">';
                        }

                        switch (get_post_meta($the_id,'dzswc_link_purchase',true)) {
                            case "customlink":
                                $the_subtitle.='<a href="'.get_post_meta($the_id,'dzswc_customlink',true).'">ADD TO CART</a>';
                                break;
                            case 'none':
                                $the_subtitle.='<span>ADD TO CART</span>';
                                break;
                            default:
                                $the_subtitle.='<a href="'.$the_link.'?add-to-cart='.$che->ID.'">ADD TO CART</a>';
                                break;
                        }



                        $the_subtitle.='</div></div>';
                    }
                }

                if ($the_subtitle != '' && $margs['skin'] != 'skin-boxed') {
                    $iout.='<div class="the-desc">';
                    $iout.=$the_subtitle;
                    $iout.='</div>';
                }

                if($margs['skin']=='skin-corporate'){
                    $iout.= $the_post_content.'';
                }


            }


//            echo 'cevahmm'.($margs['skin'] == 'skin-clean' || $margs['skin'] == 'skin-corporate' || $margs['skin'] == 'skin-accordion').' ; '.($meta_disable_content != 'on').' ; '.($the_post_content_inner!=''). $the_post_content_inner;
            if (($margs['skin'] == 'skin-boxed' || $margs['skin'] == 'skin-vintage') && $meta_disable_content != 'on' && ($the_post_content_inner != '')) {
//                echo 'hmmdadadada';
                $iout.='<div class="the-desc">';

                if ($margs['skin'] == 'skin-boxed') {
                    $iout.='<hr class="separator-short">';
                }


                $iout.= $the_post_content.'';

                //echo $str_items;
                if ($str_items != '') {
                    wp_enqueue_script('dzs.advancedscroller',$this->thepath.'advancedscroller/plugin.js');
                    wp_enqueue_style('dzs.advancedscroller',$this->thepath.'advancedscroller/plugin.css');
                }


                $iout.='</div>';
            }



            if ($margs['skin'] === 'skin-corporate') {
                $iout.='</div>'; ///===end item-meta
            }

            if (get_post_meta($the_id,'dzsp_highlight_color',true) != '') {
                if ($margs['skin'] == 'skin-default') {
                    $iout.='<style>';
                    $iout.=' #port'.$this->sliders_index.' .portitem:nth-child('.($i + 1).'):hover .the-title{ color: '.get_post_meta($the_id,'dzsp_highlight_color',true).';}';
                    $iout.=' #port'.$this->sliders_index.' .portitem:nth-child('.($i + 1).'):hover:after{ border-bottom-color: '.get_post_meta($the_id,'dzsp_highlight_color',true).'; }';
                    $iout.=' #port'.$this->sliders_index.' .portitem:nth-child('.($i + 1).'):hover{ border-bottom: 1px solid '.get_post_meta($the_id,'dzsp_highlight_color',true).';}';
                    $iout.='</style>';
                }
            }

            //------------
            //===skinblog custom markup
            if ($margs['skin'] == 'skin-blog') {
                ///===== skin blog
                $str_bg = '';
                if (get_post_meta($the_id,'dzsp_highlight_color',true) != '') {
                    $str_bg = 'background-color:'.get_post_meta($the_id,'dzsp_highlight_color',true).';';
                }
                $str_datainittop = '';
                if (get_post_meta($the_id,'dzsp_infometa_top',true) != '') {
                    $str_datainittop = ' data-inittop="'.get_post_meta($the_id,'dzsp_infometa_top',true).'"';
                }
                if (get_post_meta($the_id,'dzsp_infometa_final_top',true) != '') {
                    $str_datainittop = ' data-finaltop="'.get_post_meta($the_id,'dzsp_infometa_final_top',true).'"';
                }
                //echo $str_datainittop;
                if ($meta_disable_content != 'on') {

                    $iout.='<div class="item-meta" '.$str_datainittop.' style="'.$str_bg.'">';

//                    echo ' -- '.$the_id.'  -> '.$link_title.' <-- LINK TITLE ... ';
                    $iout.='<div class="the-title">';
                    if ($link_title != '') {
                        $iout.='<a href="'.$link_title.'"';


                        if($margs['link_open_in_new_tab']=='on' || get_post_meta($the_id,'dzsp_link_target',true)=='blank'){
                            $iout.=' target="_blank"';
                        }

                        $iout.='>';
                    }
                    $iout.=$che->post_title;
                    if ($link_title != '') {
                        $iout.='</a>';
                    }
                    $iout.='</div>';
                    $iout.='<div class="the-post-meta">';




                    if($margs['skin_blog_meta_format']){

                        if(strpos($margs['skin_blog_meta_format'], 'icon')!==false){

                            wp_enqueue_style('fontawesome','https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');
                        }

                        preg_match_all("/{{.*?}}/", $margs['skin_blog_meta_format'], $output_array);


                        foreach($output_array as $mp){


                            foreach($mp as $mpi){

                                if($mpi=='{{metadate}}' || $mpi=='{{metatags}}' || $mpi=='{{metacomments}}' ){


                                    if($mpi=='{{metadate}}'){

                                        // -- calendar
                                        $iout.='<span class="meta-property">';
                                        $iout.='<span class="icon-meta-calendar"></span>';
                                        $iout.='<span class="meta-property-content">';
                                        $iout.=get_the_time('Y-m-d',$the_id);
                                        $iout.='</span>';
                                        $iout.='</span>';
                                    }


                                    if($mpi=='{{metatags}}'){



                                        $post_terms_ids = wp_get_post_terms($the_id,'categoryportfolio',array("fields" => "ids"));
                                        $ik = 0;
                                        if (is_array($post_terms_ids) && count($post_terms_ids)) {
                                            $iout.='<span class="meta-property"><span class="icon-meta-category"></span><span class="meta-property-content">';

                                            foreach ($post_terms_ids as $post_term) {
                                                if ($ik > 0) {
                                                    $iout.=', ';
                                                }
                                                $aux_term = get_term($post_term,'categoryportfolio');
                                                //print_r($aux_term); echo ' ';
                                                $term_link = get_term_link($aux_term->slug,'categoryportfolio');
                                                $iout.='<a href="'.$term_link.'">'.$aux_term->name.'</a>';
                                                $ik++;
                                            }
                                            $iout.='</span></span>';
                                        }
                                    }

                                    if($mpi=='{{metacomments}}'){




                                        if (comments_open($the_id)) {

                                            $num_comments = get_comments_number($the_id);
                                            if ($num_comments == 0) {

                                            } else {
                                                //==comments
                                                $iout.='<span class="meta-property">';
                                                $iout.='<span class="icon-meta-comment"></span>';
                                                $iout.='<span class="meta-property-content"><a href="'.get_permalink($the_id).'#comments">';
                                                $iout.=$num_comments;
                                                $iout.=' '.__('comments','dzsp').'</a></span>';
                                                $iout.='</span>';
                                            }
                                        }
                                    }


                                }else{



                                    preg_match("/icon-(.*?),/", $mpi, $output_array2);

                                    $icon = $output_array2[1];

                                    preg_match("/cf-(.*?)}/", $mpi, $output_array2);

                                    $cf = $output_array2[1];


                                    if($cf){
                                        if(get_post_meta($the_id,$cf,true) || $cf=='permalink'){

                                            $iout.='<span class="meta-property">';
                                            if($icon){
                                                $iout.='<i class="fa fa-'.$icon.'""></i>';
                                            }
                                            $iout.='<span class="meta-property-content">';

                                            if($cf=='permalink'){


                                                $lab = __("Project Link");

                                                if($this->db_mainoptions['dzsp_translate_project_link']){
                                                    $lab = $this->db_mainoptions['dzsp_translate_project_link'];
                                                }

                                                $iout.='<a href="'.get_permalink($the_id).'">'.$lab.'</a>';
                                            }else{

                                                $iout.=get_post_meta($the_id,$cf,true);
                                            }

                                            $iout.='</span>';


                                            $iout.='</span>';
                                        }


                                    }

                                }

                            }

                        }

                    }










                    $iout.='</div>';

                    // dzs_get_excerpt($the_id,array('forceexcerpt' => false,'readmore' => 'on','maxlen' => $maxlen))
                    $iout.='<div class="the-post-content">'.$the_post_content.'</div>';
                    $iout.='</div>'; // END item-meta
                }
            }

            //$the_meta = $this->get_post_meta_all($the_id);
            //print_r($the_meta);
            //
            //echo $the_link;


            $iout.='</div>';
//            continue;





            // -------------------- ------
            // --- layered construct - ---
            // ----- ------------- -------
            if ($margs['skin'] == 'skin-default' || $margs['skin'] == 'skin-arizona') {
                $iout = '';

                $iout.='<div data-postid="'.$the_id.'" class="portitem-tobe';

                if (get_post_meta($the_id,'dzsp_extra_classes',true) != '') {
                    $iout.=' '.get_post_meta($the_id,'dzsp_extra_classes',true);
                }

                $iout.='" style="';


                $iout.=$str_item_w;
                $iout.=$str_item_h;
//                if (get_post_meta($the_id,'dzsp_force_height',true) != '') {
//                    $iout.=' data-forceheight="'.get_post_meta($the_id,'dzsp_force_height',true).'"';
//                }
//                if (get_post_meta($the_id,'dzsp_force_thumb_width',true) != '') {
//                    $iout.=' data-forcethumbwidth="'.get_post_meta($the_id,'dzsp_force_thumb_width',true).'"';
//                }
//                if (get_post_meta($the_id,'dzsp_force_thumb_height',true) != '') {
//                    $iout.=' data-forcethumbheight="'.get_post_meta($the_id,'dzsp_force_thumb_height',true).'"';
//                }


                $iout.='"';

                if($margs['skin']=='skin-arizona'){

                    if(isset($_COOKIE["like_submitted_".$the_id])){
                        $iout.=' data-submitted-like="on"';
                    }
                }


                if ($the_type == 'audio') {

                    wp_enqueue_script('dzs.audioplayer',$this->thepath.'audioplayer/audioplayer.js');
                    wp_enqueue_style('dzs.audioplayer',$this->thepath.'audioplayer/audioplayer.css');



//	                print_r($the_src);
	                // ------ if there is a featured image
	                if ($the_src[0] != '') {
		                $iout.=' data-thumbnail="'.$the_src[0].'"';
	                }
	                $iout.=' data-source_audio="'.get_post_meta($the_id,'dzsp_featured_media',true).'"';



	                if (get_post_meta($the_id,'dzsp_sourceogg',true) != '') {
		                $iout.=' data-source_audio_ogg="'.get_post_meta($the_id,'dzsp_sourceogg',true).'"';
	                }
                }


                if ($the_type == 'youtube' || $the_type == 'vimeo' || $the_type == 'video') {
                    // ---- videos

                    wp_enqueue_script('dzs.vplayer',$this->thepath."videogallery/vplayer.js");
                    wp_enqueue_style('dzs.vplayer',$this->thepath.'videogallery/vplayer.css');
                    // ------ if there is a featured image
                    if ($the_src[0] != '') {
                        $iout.=' data-thumbnail="'.$the_src[0].'"';
                    }
                    $iout.=' data-source_video="'.get_post_meta($the_id,'dzsp_featured_media',true).'"';
                }


                if($margs['skin'] == 'skin-arizona') {
                    if ($the_type == 'gallery') {

                        // ------ if there is a featured image
                        if ($the_src[0] != '') {
                            $iout .= ' data-thumbnail="' . $the_src[0] . '"';
                        }
                    }
                    if ($the_type == 'thumb') {

                        // ------ if there is a featured image
                        if (get_post_meta($the_id,'dzsp_featured_media',true)) {
                            $iout .= ' data-thumbnail="' . get_post_meta($the_id,'dzsp_featured_media',true) . '"';
                        }
                    }
                }


                if (get_post_meta($the_id,'dzsp_sourceogg',true) != '') {
                    $iout.=' data-source_video_ogg="'.get_post_meta($the_id,'dzsp_sourceogg',true).'"';
                }


                if (is_array($post_terms)) {
                    $ik = 0;
                    $iout.=' data-term_ids="';

                    foreach ($post_terms as $post_term) {


//                    print_r($post_term); echo 'ceva'; print_r($thecustomcats);
                        //$cat
                        $auxsw = false;
                        //print_r($thecustomcats);
                        if ($ik > 0) {
                            $iout.=';';
                        }
                        $iout.=$post_term->term_id;
//                    $post_term = str_replace('"','',$post_term);
//                    $iout.=htmlentities($post_term);
                        $ik++;
                    }
                    $iout.='"';



                    $ik = 0;
                    $iout.=' data-term_names="';

                    foreach ($post_terms as $post_term) {


//                    print_r($post_term); echo 'ceva'; print_r($thecustomcats);
                        //$cat
                        $auxsw = false;
                        //print_r($thecustomcats);
                        if ($ik > 0) {
                            $iout.=';';
                        }
                        $post_term_name=$post_term->name;
                        $post_term_name = str_replace('"','',$post_term_name);
                        $iout.=$post_term_name;
//                    $iout.=htmlentities($post_term);
                        $ik++;
                    }
                    $iout.='"';
                }
                $iout.=' data-typefeaturedarea="'.$dataType.'"';
                $iout.='>';



                if ($the_type == 'gallery') {
                    wp_enqueue_script('dzs.advancedscroller',$this->thepath.'advancedscroller/plugin.js');
                    wp_enqueue_style('dzs.advancedscroller',$this->thepath.'advancedscroller/plugin.css');
                    $iout.='<div class="the-feature-data">';

                    if (is_array($meta_image_gallery_images) && count($meta_image_gallery_images) > 0) {
                        foreach ($meta_image_gallery_images as $img) {
                            if ($img == '') {
                                continue;
                            }
                            $aux_po = get_post($img);

                            $the_src = '';
                            $the_thumb = '';
                            if ($aux_po && $aux_po->post_mime_type == 'video/mp4') {
                                $the_src = $aux_po->guid;
                            } else {
                                $imgsrc = wp_get_attachment_image_src($img,'full');
                                $the_src = $imgsrc[0];
                                $the_thumb = $the_src;
                            }

                            if (get_post_meta($img,'_attachment_video_thumb',true) != '') {
                                $the_thumb = get_post_meta($img,'_attachment_video_thumb',true);
                            }

                            $iout.='<img class="fullwidth" src="'.$the_src.'" style="';
                            $iout.=$str_thumb_h;
                            $iout.='"/>';
                        }
                    }

                    $iout.='</div>';
                }


                $iout.='<div class="the-feature-con " style="';


                $iout.=$str_thumb_w;
                $iout.=$str_thumb_h;
                $iout.='"';
                $iout.='>';

                if ($the_type == 'thumb' || $the_type == 'link') {
                    $iout.='<div class="the-feature" style="background-image: url('.$thumbnail_src.');"></div>';
                }
//                if($dataType=='gallery'){
//                    $iout.='<div class="the-feature advancedscroller skin-inset type-'+$dataType+'" style=""><ul class="items">';
//
//                    $iout.='</ul></div>';
//                }

                if ($the_type == 'link') {
                    $link_featuredmedia = $the_link;
                }


                $iout.='<div class="the-overlay">';
//                        <a data-biggallerythumbnail="img/t2.jpg" data-biggallery="gal1" href="img/b1.jpg" class="the-overlay-anchor content-opener" data-src="img/b1.jpg">
//                            <div class="plus-image"></div>
//                        </a>
                if ($link_featuredmedia != '') {
                    if ($the_type == 'thumb' || $the_type == 'link') {
                        $iout.='<a ';

//                        echo 'cevava' . $the_id . ' ' . $link_type_featuredmedia;

                        if ($link_type_featuredmedia === 'bigimage' && get_post_meta($the_id, 'dzsp_open_big_image_in_lightbox',true)!='off') {
                            if ($margs['settings_lightboxlibrary'] == 'prettyphoto') {
                                $iout.=' rel="prettyPhoto['.$meta_biggallery.']" title="You can add caption to pictures."';
                            } else {
                                $iout.='data-biggallerythumbnail="'.$thumbnail_src.'"';
                                if (isset($margs['settings_biggalleryall']) && $margs['settings_biggalleryall'] == 'on') {
                                    $iout.=' data-biggallery="'.'port1'.'"';
                                } else {
                                    if ($the_type == 'thumb' && $meta_biggallery != '') {
                                        $iout.=' data-biggallery="'.$meta_biggallery.'"';
                                    }
                                }
                            }
                        }


                        if($this->db_mainoptions['settings_image_hide_source']=='on' && $link_type_featuredmedia === 'bigimage'){

                            $iout.=' data-src=';
                        }else{

                            $iout.=' href=';
                        }

//                        $iout.=' -- link_featuredmedia -- > '.$link_featuredmedia.' < -- ||| ';


                        $iout.='"'.$link_featuredmedia.'" class="the-overlay-anchor';

                        if ($link_type_featuredmedia === 'content_opener') {
                            $iout.=' content-opener';
                        }

//                        $iout.='ceva'.$link_type_featuredmedia;
                        if ($link_type_featuredmedia === 'bigimage') {
                            if ($margs['settings_lightboxlibrary'] == 'prettyphoto') {

                            } else {
                                $iout.=' zoombox';
                            }
                        }
                        $iout.='" data-src="'.$link_featuredmedia.'">
<div class="plus-image"></div>
</a>';
                    }
                }

                $iout.='</div>'; //--end the-overlay
                $iout.='</div>'; // -- end the-feature-con

                if ($link_metaarea == '' || $link_metaarea == 'content_opener') {
                    $iout.='<div class="item-meta';
                    if ($link_metaarea == 'content_opener') {
                        $iout.=' content-opener';
                    }
                    $iout.='" style="">';
                } else {
                    $iout.='<a';


                    if($margs['link_open_in_new_tab']=='on'){
                        $iout.=' target="_blank"';
                    }

                    $iout.=' href="'.$link_metaarea.'" class="item-meta" style="">';
                }


                if($margs['skin'] == 'skin-arizona') {

                    if (is_array($post_terms)) {

//                        echo get_the_time('U', $the_id);
                        $str_date = human_time_diff( get_the_time('U', $the_id), current_time('timestamp') ) . __(' ago');
                        $iout.='<div class="post-the-meta">
                <div class="post-category">'.$post_terms[0]->name.'</div> <div class="post-author">Posted '.$str_date.' by <strong>admin</strong></div>
            </div>';
                    }
                }

                if ($meta_disable_title_subtitle != 'on') {
                    if ($che->post_title) {
                        $iout.='<div class="the-title">';
                        if ($link_title != '') {
                            $iout.='<a href="'.$link_title.'">';
                        }
                        $iout.=$che->post_title;
                        if ($link_title != '') {
                            $iout.='</a>';
                        }

                        $iout.='</div>';
                    }



                    if ($wpqargs['post_type'] == 'product' && ($margs['skin'] == 'skin-default' || $margs['skin'] == 'skin-commerce') && $the_subtitle == '') {

                        $the_subtitle = '';
                        $old_price = '';
                        $sale_price = '';
                        $old_price = get_post_meta($the_id,'_regular_price',true);
                        if (get_post_meta($the_id,'_sale_price',true)) {
                            $sale_price = get_post_meta($the_id,'_sale_price',true);
                        }

                        //--- if woo commerce enabled
                        if ($old_price && function_exists('get_woocommerce_currency_symbol')) {
                            if ($sale_price) {
                                $the_subtitle.='<div class="price"><span class="real-price">'.get_woocommerce_currency_symbol(get_woocommerce_currency()).$sale_price.'</span> <span class="old-price">'.get_woocommerce_currency_symbol(get_woocommerce_currency()).$old_price.'</span></div>';
                            } else {

                                $the_subtitle.='<div class="price"><span class="real-price">'.get_woocommerce_currency_symbol(get_woocommerce_currency()).$old_price.'</span></div>';
                            }

                            $the_subtitle .= '
<div class="addtocart-con">';
                            if ($margs['skin'] == 'skin-default') {
                                $the_subtitle.='<div class="button-addtocart">';
                            }
                            if ($margs['skin'] == 'skin-commerce') {
                                $the_subtitle.='<div class="addtocart-btn">';
                            }

                            switch (get_post_meta($the_id,'dzswc_link_purchase',true)) {
                                case "customlink":
                                    $the_subtitle.='<a href="'.get_post_meta($the_id,'dzswc_customlink',true).'">ADD TO CART</a>';
                                    break;
                                case 'none':
                                    $the_subtitle.='<span>ADD TO CART</span>';
                                    break;
                                default:
                                    $the_subtitle.='<a href="'.$the_link.'?add-to-cart='.$che->ID.'">ADD TO CART</a>';
                                    break;
                            }



                            $the_subtitle.='</div></div>';
                        }
                    }

                    if ($the_subtitle != '' && $margs['skin'] != 'skin-boxed') {
                        $iout.='<div class="the-desc">';
                        $iout.=$the_subtitle;
                        $iout.='</div>';
                    }
                }


//                    <div class="the-title">Paris Photoshoot</div>
//                    <div class="the-desc">June 2013</div>
                if ($link_metaarea == '' || $link_metaarea == 'content_opener') {
                    $iout.='</div>';
                } else {
                    $iout.='</a>';
                }

                if ($link_metaarea == 'content_opener' || $link_featuredmedia == 'content_opener' || $link_title == 'content_opener') {
                    $iout.=$str_big_content;
                }



                if($margs['skin'] == 'skin-arizona') {

                    $num_comments = get_comments_number($the_id);
                    $nr_likes = get_post_meta($the_id,'dzsp_likes',true);
                    $nr_dislikes = get_post_meta($the_id,'dzsp_dislikes',true);

                    if($nr_likes==''){
                        $nr_likes=0;
                    }
                    if($nr_dislikes==''){
                        $nr_dislikes=0;
                    }

                    $iout.='<div class="comments-listen"><i class="fa fa-comment" style="opacity: 0.5"></i>&nbsp;&nbsp;'.$num_comments.' '.__("comments").'</div>
        <div class="like-dislike-con ">
            <div class="like-btn"><i class="fa fa-thumbs-up" style="opacity: 0.5; color: #4cdda6;"></i>&nbsp;&nbsp;Like <span class="the-number">'.$nr_likes.'</span> </div>
            <fig class=like-circle"></fig>
            <fig class=like-circle"></fig>
            <fig class=like-circle"></fig>
            <fig class=like-circle"></fig>
            <fig class=like-circle"></fig>
            <div class="dislike-btn"><span class="the-number">'.$nr_dislikes.'</span> Dislike&nbsp;&nbsp;<i class="fa fa-thumbs-down" style="opacity: 0.5; color: #b51e2c;"></i></div>
        </div>';

                    wp_enqueue_style('fontawesome','https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');
                }

                $iout.='</div>'; //-- end portitem-tobe
            }



            // --- entering hidden thumbs for the lightbox library for project
            if ($the_type == 'thumb') {
                if (is_array($meta_image_gallery_images) && count($meta_image_gallery_images) > 0) {
                    foreach ($meta_image_gallery_images as $img) {
                        if ($img == '') {
                            continue;
                        }
                        $aux_po = get_post($img);

                        $the_src = '';
                        $the_thumb = '';
                        if ($aux_po && $aux_po->post_mime_type == 'video/mp4') {
                            $the_src = $aux_po->guid;
                        } else {
                            $imgsrc = wp_get_attachment_image_src($img,'full');
                            $the_src = $imgsrc[0];
                            $the_thumb = $the_src;
                        }

                        if (get_post_meta($img,'_attachment_video_thumb',true) != '') {
                            $the_thumb = get_post_meta($img,'_attachment_video_thumb',true);
                        }

                        //echo $imgsrc;
                        //echo 'ceva'; print_r($aux);
                        if ($margs['settings_lightboxlibrary'] == 'prettyphoto') {
                            $iout.='<a href="'.$the_src.'" class="hidden" rel="prettyPhoto['.$meta_biggallery.']" title="You can add caption to pictures."><img src="'.$the_thumb.'" width="60" height="60" alt="Red round shape" /></a>';
                        } else {
                            $iout.='<a href="'.$the_src.'" class="hidden zoombox" data-biggallery="'.$meta_biggallery.'" data-biggallerythumbnail="'.$the_thumb.'"></a>';
                        }
                    }
                }
            }
            $fout.=$iout;
        }
        return $fout;
    }

}

if (!class_exists('DZSPageBuilder')) {
    $filename = dirname(__FILE__).'/plugins/dzs-pagebuilder/pagebuilder.php';


    if (file_exists($filename)) {
        include_once($filename);
    }
}